"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApplicationCard = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const classnames_1 = __importDefault(require("classnames"));
const Link_1 = __importDefault(require("../../core/Link"));
const withStyles_1 = __importDefault(require("../../core/withStyles"));
const helpers_1 = require("../../helpers");
const ApplicationCard_styles_1 = __importDefault(require("./ApplicationCard.styles"));
const ApplicationCard = ({ classes, application, onClick, auto = false, testId, }) => {
    const { name, thumbnailUrl, websiteUrl, strings } = application.currentAppVersion;
    const cta = strings.callToAction || name;
    return ((0, jsx_runtime_1.jsxs)("div", Object.assign({ className: (0, classnames_1.default)(classes.root, auto && classes.auto) }, { children: [(0, jsx_runtime_1.jsx)("button", Object.assign({ className: classes.thumbnail, onClick: onClick }, (0, helpers_1.testAttr)(testId), { children: (0, jsx_runtime_1.jsx)("div", { className: classes.image, style: { backgroundImage: `url(${thumbnailUrl})` } }, void 0) }), void 0), cta && (0, jsx_runtime_1.jsx)("div", Object.assign({ className: classes.cta }, { children: cta }), void 0), websiteUrl && ((0, jsx_runtime_1.jsx)("div", Object.assign({ className: classes.website }, { children: (0, jsx_runtime_1.jsx)(Link_1.default, Object.assign({ href: websiteUrl, target: "_blank" }, { children: "Learn More" }), void 0) }), void 0))] }), void 0));
};
exports.ApplicationCard = ApplicationCard;
exports.default = (0, withStyles_1.default)(ApplicationCard_styles_1.default)(exports.ApplicationCard);
//# sourceMappingURL=ApplicationCard.js.map