"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const withStyles_1 = require("../../core/withStyles");
const mixins_1 = require("../../mixins");
const styles = (theme) => (0, withStyles_1.createStyles)({
    root: {
        width: theme.spacing(18),
        [theme.breakpoints.up('sm')]: {
            width: theme.spacing(24),
        },
    },
    auto: {
        width: '100%',
        maxWidth: theme.spacing(24),
    },
    thumbnail: Object.assign(Object.assign({}, (0, mixins_1.buttonReset)()), { position: 'relative', width: '100%', paddingTop: `${100 / (16 / 9)}%`, boxShadow: theme.shadows[3] }),
    image: {
        position: 'absolute',
        top: 0,
        right: 0,
        bottom: 0,
        left: 0,
        backgroundColor: '#000',
        backgroundPosition: 'center',
        backgroundSize: 'cover',
        backgroundRepeat: 'no-repeat',
        backgroundClip: 'padding-box',
    },
    cta: Object.assign({ marginTop: theme.spacing(1), fontSize: theme.fontSizes.sm, textAlign: 'center' }, (0, mixins_1.textTruncate)()),
    website: {
        marginTop: theme.spacing(1),
        fontSize: theme.fontSizes.sm,
        textAlign: 'center',
    },
});
exports.default = styles;
//# sourceMappingURL=ApplicationCard.styles.js.map