"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActionBar = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const classnames_1 = __importDefault(require("classnames"));
const withStyles_1 = __importDefault(require("../../core/withStyles"));
const withThemeSelector_1 = __importDefault(require("../../core/withThemeSelector"));
const Row_1 = __importDefault(require("../../layout/Row"));
const ActionBar_styles_1 = __importDefault(require("./ActionBar.styles"));
const ActionBarAction_1 = __importDefault(require("./ActionBarAction"));
const ActionBarInput_1 = __importDefault(require("./ActionBarInput"));
const ActionBarTitle_1 = __importDefault(require("./ActionBarTitle"));
const ActionBarSelect_1 = __importDefault(require("./ActionBarSelect"));
const ActionBarSelectOption_1 = __importDefault(require("./ActionBarSelectOption"));
const ActionBar = ({ condensed, doubleMargin, autoHeight, classes, children, }) => ((0, jsx_runtime_1.jsx)(Row_1.default, Object.assign({ className: (0, classnames_1.default)(classes.root, condensed && classes.condensed, autoHeight && classes.autoHeight), doubleMargin: doubleMargin }, { children: children }), void 0));
exports.ActionBar = ActionBar;
exports.default = Object.assign((0, withThemeSelector_1.default)((0, withStyles_1.default)(ActionBar_styles_1.default)(exports.ActionBar)), {
    Title: ActionBarTitle_1.default,
    Action: ActionBarAction_1.default,
    Input: ActionBarInput_1.default,
    Select: ActionBarSelect_1.default,
    SelectOption: ActionBarSelectOption_1.default,
});
//# sourceMappingURL=ActionBar.js.map