"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const withStyles_1 = require("../../core/withStyles");
const ActionBar_styles_1 = require("./ActionBar.styles");
const styles = (theme) => (0, withStyles_1.createStyles)({
    root: {
        display: 'flex',
        flexDirection: 'row',
        alignItems: 'center',
        color: theme.palette.text.secondary,
        padding: theme.spacing(1, 0),
        height: ActionBar_styles_1.actionBarHeight / 2,
    },
    disabled: {
        opacity: 0.4,
        cursor: 'not-allowed',
    },
    label: {
        marginLeft: theme.spacing(0.8),
        fontWeight: 700,
        lineHeight: 1.11,
        letterSpacing: 1.42,
        textTransform: 'uppercase',
        fontSize: theme.fontSizes.xs,
    },
    labelSelected: {
        color: theme.palette.text.primary,
    },
    subActionLabel: {
        marginLeft: 0,
        marginRight: theme.spacing(0.4),
    },
});
exports.default = styles;
//# sourceMappingURL=ActionBarAction.styles.js.map