"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const withStyles_1 = require("../../core/withStyles");
const ActionBar_styles_1 = require("./ActionBar.styles");
const styles = (theme) => {
    const textStyles = {
        lineHeight: 1.11,
        letterSpacing: 1.42,
        fontWeight: 600,
        fontSize: theme.fontSizes.xs,
        color: theme.palette.text.secondary,
        textTransform: 'uppercase',
    };
    return (0, withStyles_1.createStyles)({
        root: {
            height: ActionBar_styles_1.actionBarHeight / 2,
            color: theme.palette.text.secondary,
        },
        input: Object.assign(Object.assign({}, textStyles), { '&::placeholder': Object.assign({ opacity: 1 }, textStyles) }),
        underline: {
            '&:before': {
                borderBottomColor: theme.input.border,
                bottom: 2,
            },
            '&:after': {
                borderBottomColor: theme.input.border,
                bottom: 2,
            },
        },
    });
};
exports.default = styles;
//# sourceMappingURL=ActionBarInput.styles.js.map