"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const withStyles_1 = require("../../core/withStyles");
const styles = (theme) => (0, withStyles_1.createStyles)({
    '@global': {
        html: {
            fontSize: theme.typography.fontSize,
        },
        body: {
            fontFamily: theme.typography.fontFamily,
        },
        strong: {
            fontWeight: 500,
        },
        button: {
            fontFamily: theme.typography.fontFamily,
        },
    },
    // Casting to `any` because the createStyles type doesn't support arrays but in actually does
    '@font-face': theme.fontFaces,
    root: {
        width: '100%',
        height: '100%',
        display: 'flex',
        flexDirection: 'column',
        color: theme.palette.text.primary,
        fontSize: theme.fontSizes.md,
    },
});
exports.default = styles;
//# sourceMappingURL=App.styles.js.map