"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Avatar = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const Avatar_1 = __importDefault(require("@material-ui/core/Avatar"));
const styles_1 = require("../../styles");
const useStyles = (0, styles_1.makeStyles)((theme) => (0, styles_1.createStyles)({
    root: {
        // Consistent styling with Auth0's auto-generated Avatar.
        fontSize: 15,
        letterSpacing: 0.5,
        fontWeight: 400,
        backgroundColor: theme.avatar.background,
        color: theme.avatar.foreground,
    },
}));
const Avatar = ({ thumbnailUrl, name = '' }) => {
    const classes = useStyles();
    const [firstName, lastName] = name.split(' ');
    const firstInitial = firstName.charAt(0).toUpperCase();
    const lastInitial = lastName && lastName.length > 0
        ? lastName.charAt(0).toUpperCase()
        : firstName.charAt(1).toUpperCase();
    return ((0, jsx_runtime_1.jsxs)(Avatar_1.default, Object.assign({ className: classes.root, variant: "circle", src: thumbnailUrl }, { children: [firstInitial || '', lastInitial || ''] }), void 0));
};
exports.Avatar = Avatar;
exports.default = exports.Avatar;
//# sourceMappingURL=Avatar.js.map