"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Breadcrumb = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const React = __importStar(require("react"));
const Icon_1 = __importDefault(require("../Icon"));
const withStyles_1 = __importDefault(require("../withStyles"));
const Breadcrumb_styles_1 = __importDefault(require("./Breadcrumb.styles"));
const BreadcrumbCrumb_1 = __importDefault(require("./BreadcrumbCrumb"));
const Breadcrumb = ({ onBack, children, classes, }) => {
    const numberOfChildren = React.Children.count(children);
    if (numberOfChildren <= 1) {
        return (0, jsx_runtime_1.jsx)("div", Object.assign({ className: classes.root }, { children: children }), void 0);
    }
    const crumbs = [
        (0, jsx_runtime_1.jsx)(BreadcrumbCrumb_1.default, Object.assign({ onClick: onBack, noShrink: true }, { children: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: "arrowLeft", className: classes.backIcon }, void 0) }), "back"),
    ];
    React.Children.forEach(children, (child, index) => {
        crumbs.push(child);
        if (index !== numberOfChildren - 1) {
            crumbs.push((0, jsx_runtime_1.jsx)("span", Object.assign({ className: classes.separator }, { children: "/" }), `sep-${index}`));
        }
    });
    return (0, jsx_runtime_1.jsx)("div", Object.assign({ className: classes.root }, { children: crumbs }), void 0);
};
exports.Breadcrumb = Breadcrumb;
exports.default = Object.assign((0, withStyles_1.default)(Breadcrumb_styles_1.default)(exports.Breadcrumb), {
    Crumb: BreadcrumbCrumb_1.default,
});
//# sourceMappingURL=Breadcrumb.js.map