"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Button = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const Button_1 = __importDefault(require("@material-ui/core/Button"));
const classnames_1 = __importDefault(require("classnames"));
const React = __importStar(require("react"));
const helpers_1 = require("../../helpers");
const Icon_1 = __importDefault(require("../Icon"));
const withStyles_1 = __importDefault(require("../withStyles"));
const Button_styles_1 = __importDefault(require("./Button.styles"));
const Button = ({ className, label, icon, iconAlignment = 'end', color = 'default', size = 'default', hideBorder = false, disabled = false, type = 'button', fullWidth = false, children, onClick, classes, testId, }, ref) => {
    const hasIcon = !!icon;
    const hasLabel = !!label || !!children;
    const iconEl = hasIcon && ((0, jsx_runtime_1.jsx)("div", Object.assign({ className: (0, classnames_1.default)(classes.icon, hasLabel && classes.iconWithLabel, fullWidth && classes.iconWithLabelFullWidth) }, { children: typeof icon === 'string' ? (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: icon }, void 0) : icon }), void 0));
    let contents = [label || children, iconEl];
    if (iconAlignment === 'start') {
        contents = contents.reverse();
    }
    return ((0, jsx_runtime_1.jsxs)(Button_1.default, Object.assign({ ref: ref, variant: "contained", disabled: disabled, type: type, fullWidth: fullWidth, onClick: onClick, classes: {
            root: (0, classnames_1.default)(classes.button, hasIcon && !hasLabel && classes.buttonOnlyIcon, hasIcon && hasLabel && classes.buttonWithIconAndLabel, iconAlignment === 'start'
                ? classes.iconAlignStart
                : classes.iconAlignEnd, fullWidth && classes.buttonFullWidth, hideBorder && classes.hideBorder, color === 'default' && classes.default, color === 'primary' && classes.primary, color === 'destructive' && classes.destructive, color === 'progress' && classes.progress, color === 'light' && classes.light, size === 'small' && classes.small, className),
            label: classes.label,
        } }, (0, helpers_1.testAttr)(testId), { children: [contents[0], contents[1]] }), void 0));
};
exports.Button = Button;
// @ts-ignore
exports.default = (0, withStyles_1.default)(Button_styles_1.default)(React.forwardRef(exports.Button));
//# sourceMappingURL=Button.js.map