"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Card = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const Paper_1 = __importDefault(require("@material-ui/core/Paper"));
const classnames_1 = __importDefault(require("classnames"));
const withThemeSelector_1 = __importDefault(require("../../core/withThemeSelector"));
const withStyles_1 = __importDefault(require("../withStyles"));
const Card_styles_1 = __importDefault(require("./Card.styles"));
const CardActions_1 = __importDefault(require("./CardActions"));
const CardContent_1 = __importDefault(require("./CardContent"));
const CardHeading_1 = __importDefault(require("./CardHeading"));
const Card = ({ fullWidth = false, raised = false, children, onClick = () => {
    return;
}, classes, }) => ((0, jsx_runtime_1.jsx)(Paper_1.default, Object.assign({ elevation: raised ? 1 : 0, onClick: onClick, classes: {
        root: (0, classnames_1.default)(classes.card, fullWidth && classes.fullWidth),
    } }, { children: children }), void 0));
exports.Card = Card;
exports.default = Object.assign((0, withThemeSelector_1.default)((0, withStyles_1.default)(Card_styles_1.default)(exports.Card)), {
    Heading: CardHeading_1.default,
    Content: CardContent_1.default,
    Actions: CardActions_1.default,
});
//# sourceMappingURL=Card.js.map