"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Checkbox = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const Paper_1 = __importDefault(require("@material-ui/core/Paper"));
const classnames_1 = __importDefault(require("classnames"));
const helpers_1 = require("../../helpers");
const CheckboxIcon_1 = __importDefault(require("./CheckboxIcon"));
const Checkbox_styles_1 = __importDefault(require("./Checkbox.styles"));
const Checkbox = ({ className, checked, indeterminate = false, label, round, disabled, onClick, onCheckboxClick, onChange, testId, }) => {
    const classes = (0, Checkbox_styles_1.default)();
    const checkbox = ((0, jsx_runtime_1.jsxs)(Paper_1.default, Object.assign({ className: (0, classnames_1.default)(classes.inputContainer, disabled && classes.disabled, round && classes.round, indeterminate && classes.indeterminate, !label && className), elevation: 0 }, { children: [(0, jsx_runtime_1.jsx)("input", Object.assign({ type: "checkbox", className: classes.input, checked: checked, disabled: disabled, onChange: (e) => {
                    if (onChange) {
                        onChange(e.target.checked);
                    }
                }, onClick: (e) => {
                    if (onCheckboxClick)
                        onCheckboxClick(e);
                    else if (!label && onClick)
                        onClick(e);
                } }, (0, helpers_1.testAttr)(testId)), void 0), (0, jsx_runtime_1.jsx)("div", Object.assign({ className: (0, classnames_1.default)(classes.checkbox, (checked || indeterminate) && classes.checked, indeterminate && classes.indeterminate) }, { children: (checked || indeterminate) && ((0, jsx_runtime_1.jsx)(CheckboxIcon_1.default, { indeterminate: indeterminate, round: round }, void 0)) }), void 0)] }), void 0));
    if (label) {
        return ((0, jsx_runtime_1.jsxs)("label", Object.assign({ className: (0, classnames_1.default)(classes.labelContainer, disabled && classes.disabled, className), onClick: onClick }, { children: [checkbox, (0, jsx_runtime_1.jsx)("div", Object.assign({ className: classes.label }, { children: label }), void 0)] }), void 0));
    }
    return checkbox;
};
exports.Checkbox = Checkbox;
exports.default = exports.Checkbox;
//# sourceMappingURL=Checkbox.js.map