"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CollapsableSelectField = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const classnames_1 = __importDefault(require("classnames"));
const React = __importStar(require("react"));
const CollapsableSelectFieldOption_1 = __importDefault(require("./CollapsableSelectFieldOption"));
const CollapsableSelectField_styles_1 = __importDefault(require("./CollapsableSelectField.styles"));
const CollapsableSelectFieldContext_1 = __importDefault(require("./CollapsableSelectFieldContext"));
const CollapsableSelectField = ({ className, value, disabled = false, onChange, children }) => {
    const classes = (0, CollapsableSelectField_styles_1.default)();
    const isSelected = React.useCallback((optionValue) => {
        return Array.isArray(value)
            ? value.includes(optionValue)
            : value === optionValue;
    }, [value]);
    const isDisabled = React.useCallback(() => {
        return disabled;
    }, [disabled]);
    const setSelected = React.useCallback((optionValue, selected) => {
        if (Array.isArray(value)) {
            if (selected) {
                onChange([...value, optionValue]);
            }
            else {
                onChange(value.filter((v) => v !== optionValue));
            }
        }
        else {
            onChange(optionValue);
        }
    }, [value, onChange]);
    return ((0, jsx_runtime_1.jsx)(CollapsableSelectFieldContext_1.default.Provider, Object.assign({ value: { isSelected, isDisabled, setSelected } }, { children: (0, jsx_runtime_1.jsx)("div", Object.assign({ className: (0, classnames_1.default)(classes.root, className) }, { children: children }), void 0) }), void 0));
};
exports.CollapsableSelectField = CollapsableSelectField;
exports.default = Object.assign(exports.CollapsableSelectField, {
    Option: CollapsableSelectFieldOption_1.default,
});
//# sourceMappingURL=CollapsableSelectField.js.map