"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ColorField = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const React = __importStar(require("react"));
const tinycolor2_1 = __importDefault(require("tinycolor2"));
const Popover_1 = __importDefault(require("@material-ui/core/Popover"));
const ColorPicker_1 = __importDefault(require("../ColorPicker"));
const InputLabel_1 = __importDefault(require("../InputLabel"));
const styles_1 = require("../../styles");
const mixins_1 = require("../../mixins");
const ColorField = ({ label, value = '', onChange = () => { }, onClose, disabled, }) => {
    const classes = useStyles();
    // State
    const [isColorSelectorOpen, setIsColorSelectorOpen] = React.useState(false);
    // Refs
    const colorSelectorRef = React.useRef(null);
    // Memoizers
    const styles = React.useMemo(() => {
        if (!value) {
            return {
                backgroundColor: 'inherit',
                color: 'inherit',
            };
        }
        const color = (0, tinycolor2_1.default)(value);
        const isDark = color.isDark();
        return {
            backgroundColor: value,
            color: isDark ? 'rgba(255,255,255,0.9)' : 'rgba(0,0,0,0.9)',
        };
    }, [value]);
    // Callbacks
    const handleClose = React.useCallback(() => {
        setIsColorSelectorOpen(false);
        if (onClose) {
            onClose();
        }
    }, [onClose]);
    // Render
    return ((0, jsx_runtime_1.jsxs)("div", Object.assign({ className: classes.root }, { children: [(0, jsx_runtime_1.jsx)(InputLabel_1.default, { children: label }, void 0), (0, jsx_runtime_1.jsx)("button", Object.assign({ ref: colorSelectorRef, className: classes.button, style: styles, onClick: () => setIsColorSelectorOpen(true), disabled: disabled }, { children: value }), void 0), (0, jsx_runtime_1.jsx)(Popover_1.default, Object.assign({ anchorEl: colorSelectorRef.current, open: isColorSelectorOpen, onClose: handleClose, anchorOrigin: {
                    vertical: 'bottom',
                    horizontal: 'center',
                }, transformOrigin: {
                    vertical: 'top',
                    horizontal: 'center',
                } }, { children: (0, jsx_runtime_1.jsx)(ColorPicker_1.default, { value: value, onChange: onChange, onClose: handleClose }, void 0) }), void 0)] }), void 0));
};
exports.ColorField = ColorField;
const useStyles = (0, styles_1.makeStyles)((theme) => ({
    root: {},
    button: Object.assign(Object.assign({}, (0, mixins_1.buttonReset)()), { cursor: 'pointer', width: '100%', height: 40, padding: theme.spacing(1, 2), fontSize: theme.fontSizes.md, borderRadius: theme.borderRadius.sm }),
}));
exports.default = exports.ColorField;
//# sourceMappingURL=ColorField.js.map