"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DateField = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const moment_1 = __importDefault(require("@date-io/moment"));
const moment_2 = __importDefault(require("moment"));
const pickers_1 = require("@material-ui/pickers");
const Popover_1 = __importDefault(require("@material-ui/core/Popover"));
const TodaySharp_1 = __importDefault(require("@material-ui/icons/TodaySharp"));
const Cancel_1 = __importDefault(require("@material-ui/icons/Cancel"));
const CheckCircle_1 = __importDefault(require("@material-ui/icons/CheckCircle"));
const React = __importStar(require("react"));
const styles_1 = require("../../styles");
const Row_1 = __importDefault(require("../../layout/Row"));
const Spacer_1 = __importDefault(require("../../layout/Spacer"));
const TextField_1 = __importDefault(require("../TextField"));
const v2_1 = __importDefault(require("../ActionBar/v2"));
const valueToMoment = (value) => value === null ? (0, moment_2.default)() : (0, moment_2.default)(value);
const DateField = ({ value, onChange, onBlur, label = '', placeholder, helperText, error, disabled, minDate, maxDate, dateFormat = 'MMM DD YYYY', }) => {
    const classes = useStyles();
    // State
    const [date, setDate] = React.useState(() => valueToMoment(value));
    const [open, setOpen] = React.useState(false);
    // Refs
    const inputRef = React.useRef(null);
    // Memoizers
    const isDirty = React.useMemo(() => {
        return !date.isSame(value);
    }, [date, value]);
    // Callbacks
    const handleClose = React.useCallback(() => {
        setDate(valueToMoment(value));
        setOpen(false);
    }, [value]);
    const handleDone = React.useCallback(() => {
        onChange(date.format(dateFormat));
        setOpen(false);
    }, [onChange, date, dateFormat]);
    // Effects
    // Update state when value changes.
    React.useEffect(() => {
        setDate(valueToMoment(value));
    }, [value]);
    return ((0, jsx_runtime_1.jsxs)(pickers_1.MuiPickersUtilsProvider, Object.assign({ utils: moment_1.default }, { children: [(0, jsx_runtime_1.jsx)(TextField_1.default, { readOnly: true, ref: inputRef, icon: (0, jsx_runtime_1.jsx)(TodaySharp_1.default, { onClick: () => {
                        if (!disabled) {
                            setOpen(true);
                        }
                    } }, void 0), label: label, placeholder: placeholder, value: value === null ? '' : date.format(dateFormat), onClick: () => setOpen(true), onBlur: onBlur, helperText: helperText, error: error, disabled: disabled }, void 0), (0, jsx_runtime_1.jsxs)(Popover_1.default, Object.assign({ open: open, anchorEl: inputRef.current, onClose: handleClose, anchorOrigin: {
                    vertical: 'bottom',
                    horizontal: 'center',
                }, transformOrigin: {
                    vertical: 'top',
                    horizontal: 'center',
                } }, { children: [(0, jsx_runtime_1.jsx)(pickers_1.DatePicker, { variant: "static", value: date, 
                        // @ts-ignore
                        onChange: setDate, disabled: disabled, format: "MM/DD/YYYY", minDate: minDate, maxDate: maxDate }, void 0), (0, jsx_runtime_1.jsx)("div", Object.assign({ className: classes.actionsContainer }, { children: (0, jsx_runtime_1.jsxs)(Row_1.default, Object.assign({ className: classes.actions }, { children: [(0, jsx_runtime_1.jsx)(v2_1.default.Action, { icon: (0, jsx_runtime_1.jsx)(Cancel_1.default, {}, void 0), color: "error", label: "Cancel", onClick: handleClose }, void 0), (0, jsx_runtime_1.jsx)(Spacer_1.default, {}, void 0), (0, jsx_runtime_1.jsx)(v2_1.default.Action, { icon: (0, jsx_runtime_1.jsx)(CheckCircle_1.default, {}, void 0), color: "success", label: "Done", disabled: !isDirty, onClick: handleDone }, void 0)] }), void 0) }), void 0)] }), void 0)] }), void 0));
};
exports.DateField = DateField;
const useStyles = (0, styles_1.makeStyles)((theme) => (0, styles_1.createStyles)({
    actionsContainer: {
        padding: theme.spacing(3),
        paddingTop: 0,
    },
    actions: {
        paddingTop: theme.spacing(3),
        borderTop: `1px solid ${theme.actionBar.border}`,
    },
}));
exports.default = exports.DateField;
//# sourceMappingURL=DateField.js.map