"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileDropper = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const React = __importStar(require("react"));
const Overlay_1 = __importDefault(require("../../internal/Overlay"));
const withStyles_1 = __importDefault(require("../withStyles"));
const withThemeSelector_1 = __importDefault(require("../withThemeSelector"));
const FileDropper_styles_1 = __importDefault(require("./FileDropper.styles"));
class FileDropper extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            isDragging: false,
        };
        this.onDragOver = (e) => {
            e.preventDefault();
        };
        this.onDragEnter = (e) => {
            this.dragTarget = e.target;
            this.setState({ isDragging: true });
        };
        this.onDragLeave = (e) => {
            // guard against child elements firing ondragleave by making sure
            // dragleave is fired for the same element that started the drag
            if (e.target === this.dragTarget) {
                this.setState({ isDragging: false });
            }
        };
        this.onDrop = (e) => {
            e.preventDefault();
            this.setState({ isDragging: false });
            this.props.onDrop(e.dataTransfer.files);
        };
    }
    componentDidMount() {
        this.attachDragListeners();
    }
    componentWillUnmount() {
        this.removeDragListeners();
    }
    attachDragListeners() {
        document.addEventListener('dragover', this.onDragOver, false);
        document.addEventListener('dragenter', this.onDragEnter, false);
        document.addEventListener('dragleave', this.onDragLeave, false);
    }
    removeDragListeners() {
        document.removeEventListener('dragover', this.onDragOver);
        document.removeEventListener('dragenter', this.onDragEnter);
        document.removeEventListener('dragleave', this.onDragLeave);
    }
    render() {
        const { title, classes } = this.props;
        const { isDragging } = this.state;
        if (!isDragging)
            return null;
        return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Overlay_1.default, { className: classes.overlay }, void 0), (0, jsx_runtime_1.jsx)("div", Object.assign({ className: classes.root, onDrop: this.onDrop }, { children: (0, jsx_runtime_1.jsx)("div", Object.assign({ className: classes.title }, { children: title }), void 0) }), void 0)] }, void 0));
    }
}
exports.FileDropper = FileDropper;
exports.default = (0, withThemeSelector_1.default)((0, withStyles_1.default)(FileDropper_styles_1.default)(FileDropper), 'dark');
//# sourceMappingURL=FileDropper.js.map