"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileField = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const classnames_1 = __importDefault(require("classnames"));
const React = __importStar(require("react"));
const Icon_1 = __importDefault(require("../Icon"));
const InputLabel_1 = __importDefault(require("../InputLabel"));
const Input_1 = __importDefault(require("../Input"));
const InputHelperText_1 = __importDefault(require("../InputHelperText"));
const withStyles_1 = __importDefault(require("../withStyles"));
const FileField_styles_1 = __importDefault(require("./FileField.styles"));
const getFileNames = (value) => {
    if (!value)
        return '';
    return Array.from(value || [])
        .map((f) => f.name)
        .join(', ');
};
const FileField = ({ label, value, accept = ['*'], multiple = false, disabled = false, error = false, helperText = '', onChange = () => {
    return;
}, onClear, onBlur, classes, }) => {
    const shouldShowClear = !!value && !!onClear;
    const fileInput = React.createRef();
    return ((0, jsx_runtime_1.jsxs)("div", Object.assign({ className: classes.root }, { children: [(0, jsx_runtime_1.jsx)(InputLabel_1.default, Object.assign({ error: error, disabled: disabled }, { children: label }), void 0), (0, jsx_runtime_1.jsxs)("div", Object.assign({ className: classes.inputWrapper }, { children: [(0, jsx_runtime_1.jsx)(Input_1.default, { type: "text", icon: shouldShowClear && ((0, jsx_runtime_1.jsx)("button", Object.assign({ className: classes.clear, onClick: () => onClear() }, { children: (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: "remove" }, void 0) }), void 0)), value: getFileNames(value), onFocus: () => { var _a; return (_a = fileInput === null || fileInput === void 0 ? void 0 : fileInput.current) === null || _a === void 0 ? void 0 : _a.focus(); }, disabled: disabled, error: error }, void 0), (0, jsx_runtime_1.jsx)("input", { ref: fileInput, disabled: disabled, className: (0, classnames_1.default)(classes.input, value && classes.inputHasValue, disabled && classes.disabled), type: "file", title: "" // hide hover tooltip
                        , accept: accept.join(','), multiple: multiple, onChange: (e) => {
                            if (e.target.files) {
                                onChange(e.target.files);
                            }
                        }, onBlur: onBlur }, void 0)] }), void 0), helperText && ((0, jsx_runtime_1.jsx)(InputHelperText_1.default, Object.assign({ indent: true, error: error, disabled: disabled }, { children: helperText }), void 0))] }), void 0));
};
exports.FileField = FileField;
exports.default = (0, withStyles_1.default)(FileField_styles_1.default)(exports.FileField);
//# sourceMappingURL=FileField.js.map