"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Icon = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const classnames_1 = __importDefault(require("classnames"));
const withStyles_1 = __importDefault(require("../withStyles"));
const Icon_styles_1 = __importDefault(require("./Icon.styles"));
const paths_1 = __importDefault(require("./paths"));
const Icon = ({ icon, title, className, classes, }) => {
    if (!paths_1.default[icon]) {
        console.warn(`Unsupported icon '${icon}' used in <Icon />`); // tslint:disable-line no-console
        return null;
    }
    const { path, viewBox } = paths_1.default[icon];
    return ((0, jsx_runtime_1.jsxs)("svg", Object.assign({ viewBox: viewBox, className: (0, classnames_1.default)(classes.icon, className) }, { children: [(0, jsx_runtime_1.jsx)("path", { d: path }, void 0), title && (0, jsx_runtime_1.jsx)("title", { children: title }, void 0)] }), void 0));
};
exports.Icon = Icon;
exports.default = (0, withStyles_1.default)(Icon_styles_1.default)(exports.Icon);
//# sourceMappingURL=Icon.js.map