"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImagePickerField = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const React = __importStar(require("react"));
const helpers_1 = require("../../helpers");
const FormHelperText_1 = __importDefault(require("../../internal/FormHelperText"));
const Column_1 = __importDefault(require("../../layout/Column"));
const withStyles_1 = __importDefault(require("../withStyles"));
const ImagePickerField_styles_1 = __importDefault(require("./ImagePickerField.styles"));
const ImagePickerFieldOption_1 = __importDefault(require("./ImagePickerFieldOption"));
class ImagePickerField extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            orderedChildren: [],
        };
    }
    static getDerivedStateFromProps(props, state) {
        // Only reorder children on mount and when the child options have changed.
        // We don't want to reorder as the user selects items.
        const shouldSortChildren = (0, helpers_1.hasMissingChildValue)(state.orderedChildren, 
        // @ts-ignore
        props.children);
        return shouldSortChildren
            ? // @ts-ignore
                { orderedChildren: (0, helpers_1.sortChildrenBySelected)(props.value, props.children) }
            : null;
    }
    render() {
        const { value, onChange, helperText, error, onBlur } = this.props;
        const { orderedChildren } = this.state;
        return ((0, jsx_runtime_1.jsx)("div", Object.assign({ onBlur: onBlur }, { children: (0, jsx_runtime_1.jsxs)(Column_1.default, { children: [orderedChildren.map((child) => {
                        const isOptionSelected = (0, helpers_1.isElementSelected)(value, child);
                        const optionValue = child.props.value;
                        return React.cloneElement(child, {
                            checked: isOptionSelected,
                            onClick: () => {
                                if (isOptionSelected) {
                                    onChange(value.filter((item) => item !== optionValue));
                                }
                                else {
                                    onChange([...value, optionValue]);
                                }
                            },
                        });
                    }), (0, jsx_runtime_1.jsx)(FormHelperText_1.default, Object.assign({ error: error }, { children: helperText }), void 0)] }, void 0) }), void 0));
    }
}
exports.ImagePickerField = ImagePickerField;
ImagePickerField.defaultProps = {
    error: false,
    helperText: '',
    children: [],
};
exports.default = Object.assign((0, withStyles_1.default)(ImagePickerField_styles_1.default)(ImagePickerField), {
    Option: ImagePickerFieldOption_1.default,
});
//# sourceMappingURL=ImagePickerField.js.map