"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Input = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const classnames_1 = __importDefault(require("classnames"));
const React = __importStar(require("react"));
const react_text_mask_1 = __importDefault(require("react-text-mask"));
const helpers_1 = require("../../helpers");
const Icon_1 = __importDefault(require("../Icon"));
const Input_styles_1 = __importDefault(require("./Input.styles"));
const Input = ({ value = '', type = 'text', placeholder, readOnly, error = false, disabled = false, maxLength, max, min, multiline = false, multilineHeight, autoFocus = false, icon = null, mask, maskGuide = false, maskPlaceholderChar = '_', keepCharPositions = false, pipe, onChange = () => { }, onBlur, onFocus, onClick, testId, className, }, ref) => {
    const inputProps = Object.assign({ type: mask ? 'text' : type, disabled,
        value,
        placeholder,
        readOnly,
        maxLength,
        max,
        min,
        onBlur,
        onFocus,
        autoFocus,
        onClick }, (0, helpers_1.testAttr)(testId));
    const classes = (0, Input_styles_1.default)();
    const inputClassName = (0, classnames_1.default)(classes.input, icon && classes.inputWithIcon, error && classes.error, disabled && classes.disabled, className);
    const handleChange = React.useCallback((e) => {
        if (onChange) {
            onChange(e.target.value);
        }
    }, [onChange]);
    const renderInput = (refOrMaskedRef, maskedInputProps) => {
        let inputEl = null;
        if (multiline && !mask) {
            inputEl = ((0, jsx_runtime_1.jsx)("textarea", Object.assign({ ref: refOrMaskedRef, className: inputClassName, onChange: handleChange, style: { height: multilineHeight } }, inputProps), void 0));
        }
        else {
            inputEl = ((0, jsx_runtime_1.jsx)("input", Object.assign({ className: inputClassName, ref: refOrMaskedRef }, inputProps, maskedInputProps), void 0));
        }
        const iconEl = typeof icon === 'string' ? (0, jsx_runtime_1.jsx)(Icon_1.default, { icon: icon }, void 0) : icon;
        return ((0, jsx_runtime_1.jsxs)("div", Object.assign({ className: (0, classnames_1.default)(classes.root, multiline && classes.multiline), style: { minHeight: multiline ? multilineHeight : 'none' } }, { children: [inputEl, iconEl && (0, jsx_runtime_1.jsx)("div", Object.assign({ className: classes.icon }, { children: iconEl }), void 0)] }), void 0));
    };
    if (mask) {
        return ((0, jsx_runtime_1.jsx)(react_text_mask_1.default, { placeholder: "", mask: mask, guide: maskGuide, placeholderChar: maskPlaceholderChar, pipe: pipe, keepCharPositions: keepCharPositions, onChange: handleChange, render: renderInput }, void 0));
    }
    return renderInput(ref, {
        onChange: (e) => onChange(e.target.value),
    });
};
exports.Input = Input;
// @ts-ignore
exports.default = React.forwardRef(exports.Input);
//# sourceMappingURL=Input.js.map