"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Link = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const classnames_1 = __importDefault(require("classnames"));
const withStyles_1 = __importDefault(require("../../core/withStyles"));
const helpers_1 = require("../../helpers");
const Link_styles_1 = __importDefault(require("./Link.styles"));
const isRenderFn = (value) => typeof value === 'function';
const Link = ({ className, 
// eslint-disable-next-line no-script-url
href = 'javascript:;', fullWidth = false, active = false, disabled = false, underline = false, color, target, onClick, children, classes, testId, }) => {
    if (isRenderFn(children)) {
        return children({
            className: (0, classnames_1.default)(classes.root, fullWidth && classes.fullWidth, underline && classes.underline, className),
            activeClassName: classes.active,
        });
    }
    return ((0, jsx_runtime_1.jsx)("a", Object.assign({ className: (0, classnames_1.default)(classes.root, fullWidth && classes.fullWidth, active && classes.active, disabled && classes.disabled, underline && classes.underline, className), href: href, target: target, onClick: disabled
            ? (0, helpers_1.preventDefault)()
            : onClick &&
                (0, helpers_1.preventDefault)(onClick), style: { color } }, (0, helpers_1.testAttr)(testId), { children: children }), void 0));
};
exports.Link = Link;
exports.default = (0, withStyles_1.default)(Link_styles_1.default)(exports.Link);
//# sourceMappingURL=Link.js.map