"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListField = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const classnames_1 = __importDefault(require("classnames"));
const React = __importStar(require("react"));
const react_beautiful_dnd_1 = require("react-beautiful-dnd");
const helpers_1 = require("../../helpers");
const AlertIcon_1 = __importDefault(require("../AlertIcon"));
const Icon_1 = __importDefault(require("../Icon"));
const withStyles_1 = __importDefault(require("../withStyles"));
const ListField_styles_1 = __importDefault(require("./ListField.styles"));
class ListField extends React.Component {
    constructor() {
        super(...arguments);
        this.onDragEnd = ({ source, destination }) => {
            const { value, onChange } = this.props;
            // Dropped outside the list.
            if (!destination)
                return;
            const reordered = (0, helpers_1.reorder)(value, source.index, destination.index);
            onChange(reordered);
        };
        this.renderItem = (item, index) => {
            const { classes, onItemClick, getItemKey, getItemLabel, hasItemError } = this.props;
            // @ts-ignore
            const key = `${getItemKey(item, index)}`;
            const hasError = hasItemError ? hasItemError(item, index) : false;
            return ((0, jsx_runtime_1.jsx)(react_beautiful_dnd_1.Draggable, Object.assign({ draggableId: key, index: index }, { children: ({ innerRef, draggableProps, dragHandleProps, placeholder }) => ((0, jsx_runtime_1.jsxs)("div", { children: [(0, jsx_runtime_1.jsxs)("div", Object.assign({ ref: innerRef }, draggableProps, dragHandleProps, { className: classes.item }, { children: [(0, jsx_runtime_1.jsx)("div", Object.assign({ className: classes.itemLabel, onClick: () => onItemClick(item, index), role: "button", tabIndex: 0 }, { children: getItemLabel(item, index) }), void 0), hasError && (0, jsx_runtime_1.jsx)(AlertIcon_1.default, {}, void 0)] }), void 0), placeholder] }, void 0)) }), key));
        };
    }
    render() {
        const { value, addLabel, onAdd, addDisabled, classes } = this.props;
        return ((0, jsx_runtime_1.jsxs)("div", Object.assign({ className: classes.root }, { children: [(0, jsx_runtime_1.jsx)(react_beautiful_dnd_1.DragDropContext, Object.assign({ onDragEnd: this.onDragEnd }, { children: (0, jsx_runtime_1.jsx)(react_beautiful_dnd_1.Droppable, Object.assign({ droppableId: "droppable" }, { children: ({ innerRef, placeholder }) => ((0, jsx_runtime_1.jsxs)("div", { children: [(0, jsx_runtime_1.jsx)("div", Object.assign({ ref: innerRef }, { children: value.map(this.renderItem) }), void 0), placeholder] }, void 0)) }), void 0) }), void 0), (0, jsx_runtime_1.jsxs)("button", Object.assign({ className: (0, classnames_1.default)(classes.add, addDisabled && classes.addDisabled), onClick: onAdd, disabled: addDisabled }, { children: [(0, jsx_runtime_1.jsx)(Icon_1.default, { icon: "add", className: classes.addIcon }, void 0), (0, jsx_runtime_1.jsx)("div", Object.assign({ className: classes.addLabel }, { children: addLabel }), void 0)] }), void 0)] }), void 0));
    }
}
exports.ListField = ListField;
ListField.defaultProps = {
    value: [],
    getItemLabel: (item) => item,
    getItemKey: (_, index) => `${index}`,
    hasItemError: () => false,
    addLabel: 'Add a new item',
    addDisabled: false,
};
exports.default = (0, withStyles_1.default)(ListField_styles_1.default)(ListField);
//# sourceMappingURL=ListField.js.map