"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const mixins_1 = require("../../mixins");
const withStyles_1 = require("../withStyles");
const styles = (theme) => (0, withStyles_1.createStyles)({
    root: {},
    item: {
        // prevent text selection while drag and dropping
        userSelect: 'none',
        display: 'flex',
        alignItems: 'center',
        borderBottom: `1px solid ${theme.button.border}`,
    },
    itemLabel: Object.assign(Object.assign({}, (0, mixins_1.buttonReset)()), { flex: 1, minHeight: '1em', paddingTop: theme.spacing(1), paddingBottom: theme.spacing(0.5) }),
    icon: {
        height: 14,
        width: 'auto',
        padding: theme.spacing(0, 1),
        cursor: 'move',
    },
    add: Object.assign(Object.assign({}, (0, mixins_1.buttonReset)()), { display: 'block', width: '100%', padding: theme.spacing(2) }),
    addDisabled: {
        opacity: 0.5,
        cursor: 'not-allowed',
    },
    addIcon: {
        display: 'block',
        margin: '0 auto',
        marginBottom: theme.spacing(0.5),
    },
    addLabel: Object.assign(Object.assign({}, (0, mixins_1.textTruncate)()), { textAlign: 'center' }),
});
exports.default = styles;
//# sourceMappingURL=ListField.styles.js.map