"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Menu = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const classnames_1 = __importDefault(require("classnames"));
const withStyles_1 = __importDefault(require("../../core/withStyles"));
const Menu_styles_1 = __importDefault(require("./Menu.styles"));
const MenuBack_1 = __importDefault(require("./MenuBack"));
const MenuDrawer_1 = __importDefault(require("./MenuDrawer"));
const MenuDrawerCTA_1 = __importDefault(require("./MenuDrawerCTA"));
const MenuDrawerItem_1 = __importDefault(require("./MenuDrawerItem"));
const MenuHeader_1 = __importDefault(require("./MenuHeader"));
const MenuItem_1 = __importDefault(require("./MenuItem"));
const MenuLogo_1 = __importDefault(require("./MenuLogo"));
const MenuTitle_1 = __importDefault(require("./MenuTitle"));
const Menu = ({ fixed = false, classes, children, }) => {
    return ((0, jsx_runtime_1.jsx)("div", Object.assign({ className: (0, classnames_1.default)(classes.root, fixed && classes.fixed) }, { children: children }), void 0));
};
exports.Menu = Menu;
exports.default = Object.assign((0, withStyles_1.default)(Menu_styles_1.default)(exports.Menu), {
    Header: MenuHeader_1.default,
    Logo: MenuLogo_1.default,
    Item: MenuItem_1.default,
    Back: MenuBack_1.default,
    Drawer: MenuDrawer_1.default,
    DrawerItem: MenuDrawerItem_1.default,
    DrawerCTA: MenuDrawerCTA_1.default,
    Title: MenuTitle_1.default,
});
//# sourceMappingURL=Menu.js.map