"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.menuHeaderHeight = void 0;
const withStyles_1 = require("../../core/withStyles");
exports.menuHeaderHeight = 68;
const styles = (theme) => (0, withStyles_1.createStyles)({
    root: {
        position: 'relative',
        color: theme.menu.foreground,
        backgroundColor: theme.palette.background.default,
        borderBottom: '1px solid transparent',
        zIndex: theme.zIndex.menu + 10,
        transition: 'background-color 0.15s ease-in',
        width: '100%',
        padding: theme.spacing(0, 4),
        [theme.breakpoints.down('xs')]: {
            padding: theme.spacing(0, 1),
        },
    },
    shadow: {
        boxShadow: theme.shadows[1],
    },
    inner: {
        display: 'flex',
        flexDirection: 'row',
        alignItems: 'center',
        height: exports.menuHeaderHeight,
        padding: theme.spacing(0, 2),
    },
});
exports.default = styles;
//# sourceMappingURL=MenuHeader.styles.js.map