"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MenuItem = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const classnames_1 = __importDefault(require("classnames"));
const withStyles_1 = __importDefault(require("../../core/withStyles"));
const helpers_1 = require("../../helpers");
const MenuItem_styles_1 = __importDefault(require("./MenuItem.styles"));
const isRenderFn = (value) => typeof value === 'function';
const MenuItem = ({ label, active = false, href = '', target, onClick, classes, children, }) => {
    if (isRenderFn(children)) {
        return children({
            className: classes.root,
            activeClassName: classes.active,
        });
    }
    return ((0, jsx_runtime_1.jsx)("a", Object.assign({ href: href, target: target, className: (0, classnames_1.default)(classes.root, active && classes.active) }, (onClick ? { onClick: (0, helpers_1.preventDefault)(onClick) } : {}), { children: label }), void 0));
};
exports.MenuItem = MenuItem;
exports.default = (0, withStyles_1.default)(MenuItem_styles_1.default)(exports.MenuItem);
//# sourceMappingURL=MenuItem.js.map