"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Modal = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const React = __importStar(require("react"));
const ReactDOM = __importStar(require("react-dom"));
const helpers_1 = require("../../helpers");
const Overlay_1 = __importDefault(require("../../internal/Overlay"));
const App_1 = require("../App");
const withStyles_1 = __importDefault(require("../withStyles"));
const withThemeSelector_1 = __importDefault(require("../withThemeSelector"));
const Modal_styles_1 = __importDefault(require("./Modal.styles"));
class Modal extends React.Component {
    constructor() {
        super(...arguments);
        this.el = typeof document !== 'undefined' ? document.createElement('div') : null;
    }
    componentDidMount() {
        if (this.props.modalRoot && this.el) {
            this.props.modalRoot.appendChild(this.el);
        }
    }
    componentWillUnmount() {
        if (this.props.modalRoot && this.el) {
            this.props.modalRoot.removeChild(this.el);
        }
    }
    render() {
        const { open, onOverlayClick, children, classes, testId } = this.props;
        if (!open)
            return null;
        if (!this.el)
            return null;
        return ReactDOM.createPortal((0, jsx_runtime_1.jsxs)("div", Object.assign({ className: classes.root }, (0, helpers_1.testAttr)(testId), { children: [(0, jsx_runtime_1.jsx)(Overlay_1.default, { className: classes.overlay, onClick: onOverlayClick, testId: `${testId}-overlay` }, void 0), (0, jsx_runtime_1.jsx)("div", Object.assign({ className: classes.modal }, { children: children }), void 0)] }), void 0), this.el);
    }
}
exports.Modal = Modal;
const ModalWithStyles = (0, withThemeSelector_1.default)((0, withStyles_1.default)(Modal_styles_1.default)(Modal));
const ModalRoot = (props) => ((0, jsx_runtime_1.jsx)(App_1.AppContext.Consumer, { children: (appContextProps) => (0, jsx_runtime_1.jsx)(ModalWithStyles, Object.assign({}, props, appContextProps), void 0) }, void 0));
exports.default = ModalRoot;
//# sourceMappingURL=Modal.js.map