"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MultiSelectField = exports.MultiSelectFieldSortBy = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const classnames_1 = __importDefault(require("classnames"));
const React = __importStar(require("react"));
const helpers_1 = require("../../helpers");
const InputLabel_1 = __importDefault(require("../InputLabel"));
const InputHelperText_1 = __importDefault(require("../InputHelperText"));
const withStyles_1 = __importDefault(require("../withStyles"));
const MultiSelectField_styles_1 = __importDefault(require("./MultiSelectField.styles"));
const MultiSelectFieldOption_1 = __importDefault(require("./MultiSelectFieldOption"));
const MultiSelectFieldSearchBox_1 = __importDefault(require("./MultiSelectFieldSearchBox"));
var MultiSelectFieldSortBy;
(function (MultiSelectFieldSortBy) {
    MultiSelectFieldSortBy["default"] = "default";
    MultiSelectFieldSortBy["label"] = "label";
    MultiSelectFieldSortBy["rightLabel"] = "rightLabel";
})(MultiSelectFieldSortBy = exports.MultiSelectFieldSortBy || (exports.MultiSelectFieldSortBy = {}));
const toNumber = (value) => {
    const numberString = (value || '')
        .split('')
        .filter((c) => c.match(/[.0-9]/g))
        .join('');
    return parseFloat(numberString);
};
const applyOrder = (children, orderedChildren) => {
    return orderedChildren
        .map((child) => children.find((c) => c.props.value === child.props.value))
        .filter((c) => c);
};
class MultiSelectField extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            orderedChildren: [],
            searchTerm: '',
        };
        this.sortWith = (getter, sortType) => (c1, c2) => {
            const value1 = getter(c1);
            const value2 = getter(c2);
            if (sortType === 'number') {
                const number1 = toNumber(String(value1));
                const number2 = toNumber(String(value2));
                return isNaN(number1) || number1 > number2 ? 1 : -1;
            }
            else if (sortType === 'boolean') {
                return value1 > value2 ? 1 : -1;
            }
            return (value1 || '').localeCompare(value2 || '');
        };
        this.sortChildren = () => {
            const { sortMode } = this.state;
            if (!sortMode) {
                return this.state.orderedChildren;
            }
            const orderedChildren = [...this.state.orderedChildren];
            if (sortMode.by === MultiSelectFieldSortBy.label) {
                orderedChildren.sort(this.sortWith((c) => c.props.label, 
                // @ts-ignore
                sortMode.type));
            }
            else if (sortMode.by === MultiSelectFieldSortBy.rightLabel) {
                orderedChildren.sort(this.sortWith(
                // @ts-ignore
                (c) => c.props.rightLabel, sortMode.type));
            }
            if (sortMode.isReverseSort) {
                orderedChildren.reverse();
            }
            return orderedChildren;
        };
    }
    static getDerivedStateFromProps(props, state) {
        // Only reorder children on mount and when the child options have changed.
        // We don't want to reorder as the user selects items.
        const shouldSortChildren = (0, helpers_1.hasMissingChildValue)(state.orderedChildren, 
        // @ts-ignore
        props.children);
        if (shouldSortChildren) {
            return {
                // @ts-ignore
                orderedChildren: (0, helpers_1.sortChildrenBySelected)(props.value, props.children),
            };
        }
        else {
            return {
                // @ts-ignore
                orderedChildren: applyOrder(props.children, state.orderedChildren),
            };
        }
    }
    render() {
        const { label, value, onChange, selectable, disabled, searchable, helperText, error, classes, onBlur, sortable, } = this.props;
        const { searchTerm } = this.state;
        let orderedChildren = this.sortChildren();
        if (searchable && searchTerm) {
            orderedChildren = orderedChildren.filter((child) => (child.props.label || '')
                .toLowerCase()
                .includes(searchTerm.toLowerCase()));
        }
        return ((0, jsx_runtime_1.jsxs)("div", Object.assign({ className: classes.root, onBlur: onBlur }, { children: [(0, jsx_runtime_1.jsx)(InputLabel_1.default, Object.assign({ error: error }, { children: label }), void 0), (0, jsx_runtime_1.jsxs)("div", Object.assign({ className: (0, classnames_1.default)(classes.contentWrapper, {
                        [classes.withSearch]: searchable,
                    }) }, { children: [searchable && ((0, jsx_runtime_1.jsx)(MultiSelectFieldSearchBox_1.default, { value: value, options: orderedChildren, searchTerm: searchTerm, disabled: disabled, sortable: sortable, onChange: onChange, onSearchChange: (newSearchTerm) => this.setState({ searchTerm: newSearchTerm }), onSortChange: (newSortMode) => this.setState({ sortMode: newSortMode }) }, void 0)), (0, jsx_runtime_1.jsx)("div", Object.assign({ className: (0, classnames_1.default)(classes.items, disabled && classes.disabled) }, { children: orderedChildren.map((child) => {
                                const isOptionSelected = (0, helpers_1.isElementSelected)(value, child);
                                const optionValue = child.props.value;
                                return React.cloneElement(child, {
                                    disabled,
                                    selectable,
                                    checked: isOptionSelected,
                                    onClick: () => {
                                        if (isOptionSelected) {
                                            onChange(value.filter((item) => item !== optionValue));
                                        }
                                        else {
                                            onChange([...value, optionValue]);
                                        }
                                    },
                                });
                            }) }), void 0)] }), void 0), (0, jsx_runtime_1.jsx)(InputHelperText_1.default, Object.assign({ error: error }, { children: helperText }), void 0)] }), void 0));
    }
}
exports.MultiSelectField = MultiSelectField;
MultiSelectField.defaultProps = {
    disabled: false,
    searchable: false,
    error: false,
    helperText: '',
    children: [],
    sortable: [],
};
exports.default = Object.assign((0, withStyles_1.default)(MultiSelectField_styles_1.default)(MultiSelectField), {
    Option: MultiSelectFieldOption_1.default,
});
//# sourceMappingURL=MultiSelectField.js.map