"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const mixins_1 = require("../../mixins");
const withStyles_1 = require("../withStyles");
const styles = (theme) => (0, withStyles_1.createStyles)({
    root: {
        width: '100%',
    },
    items: Object.assign({ 
        // A magic number so we partially show the 3rd item to indicate that
        // the user can scroll.
        maxHeight: 212, minHeight: 104, boxSizing: 'border-box', padding: theme.spacing(1), display: 'flex', flexDirection: 'column' }, (0, mixins_1.scrollable)()),
    disabled: {
        overflow: 'hidden',
    },
    contentWrapper: {
        backgroundColor: theme.palette.background.default,
        borderRadius: theme.borderRadius.lg,
        boxShadow: `0px 3px 9px ${theme.palette.divider}`,
        '&$withSearch': {
            paddingTop: theme.spacing(1),
        },
    },
    withSearch: {},
});
exports.default = styles;
//# sourceMappingURL=MultiSelectField.styles.js.map