"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SearchBox = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const React = __importStar(require("react"));
const Close_1 = __importDefault(require("@material-ui/icons/Close"));
const Search_1 = __importDefault(require("@material-ui/icons/Search"));
const FilterList_1 = __importDefault(require("@material-ui/icons/FilterList"));
const withStyles_1 = __importDefault(require("../withStyles"));
const MultiSelectFieldSearchBox_styles_1 = __importDefault(require("./MultiSelectFieldSearchBox.styles"));
const Checkbox_1 = __importDefault(require("../Checkbox"));
const v2_1 = __importDefault(require("../ActionBar/v2"));
const helpers_1 = require("../../helpers");
const MultiSelectFieldSortSelect_1 = __importDefault(require("./MultiSelectFieldSortSelect"));
class SearchBox extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            isSearchMode: false,
            isSortMode: false,
        };
    }
    componentDidMount() {
        const { sortable, onSortChange } = this.props;
        const { sortMode } = this.state;
        const firstSortOption = sortable && sortable[0];
        if (firstSortOption && sortMode === undefined) {
            const defaultSortMode = {
                label: firstSortOption.label,
                by: firstSortOption.by,
                type: firstSortOption.type,
                isReverseSort: firstSortOption.defaultDirection === 'desc',
            };
            this.setState({ sortMode: defaultSortMode });
            onSortChange(defaultSortMode);
        }
    }
    render() {
        const { value, options, searchTerm, onChange, onSearchChange, onSortChange, disabled, classes, sortable, } = this.props;
        const { isSearchMode, isSortMode, sortMode } = this.state;
        const numChecked = options
            .map((option) => (0, helpers_1.isElementSelected)(value, option))
            .filter((c) => c).length;
        const checked = options.length > 0 && numChecked === options.length;
        const indeterminate = options.length > 0 && numChecked > 0 && numChecked < options.length;
        const showingValue = options.map((option) => option.props.value);
        const multiSelectAction = ((0, jsx_runtime_1.jsx)(Checkbox_1.default, { className: classes.checkBox, disabled: disabled, checked: checked, indeterminate: indeterminate, onClick: (e) => {
                e.preventDefault();
                if (checked || indeterminate) {
                    onChange(value.filter((item) => !showingValue.includes(item)));
                }
                else {
                    const newValue = showingValue.filter((v) => !value.includes(v));
                    onChange([...value, ...newValue]);
                }
            } }, void 0));
        const onSortOptionSelect = (newSortMode) => {
            this.setState({ isSortMode: false, sortMode: newSortMode });
            onSortChange(newSortMode);
        };
        const sortAction = sortable && sortable.length > 0 && ((0, jsx_runtime_1.jsx)(v2_1.default.Select, Object.assign({ icon: (0, jsx_runtime_1.jsx)(FilterList_1.default, { className: classes.sortIcon }, void 0), open: isSortMode, onOpen: () => this.setState(({ isSortMode: prevIsSortMode }) => ({
                isSortMode: !prevIsSortMode,
            })), disabled: disabled }, { children: sortable.map((sortOption, index) => ((0, jsx_runtime_1.jsx)(MultiSelectFieldSortSelect_1.default, { sortMode: sortMode, sortOption: sortOption, onSelect: onSortOptionSelect }, index))) }), void 0));
        const searchAction = isSearchMode ? ((0, jsx_runtime_1.jsx)(v2_1.default.Input, { autoFocus: true, label: "Search", disabled: disabled, maxWidth: 145, className: classes.searchInput, icon: (0, jsx_runtime_1.jsx)(v2_1.default.Action, { icon: (0, jsx_runtime_1.jsx)(Close_1.default, { className: classes.closeIcon }, void 0), onClick: (e) => {
                    e.preventDefault();
                    this.setState({ isSearchMode: false });
                    onSearchChange('');
                } }, void 0), value: searchTerm, onChange: onSearchChange }, void 0)) : ((0, jsx_runtime_1.jsx)(v2_1.default.Action, { className: classes.searchInputWrapper, icon: (0, jsx_runtime_1.jsx)(Search_1.default, { className: classes.searchIcon }, void 0), disabled: disabled, onClick: () => this.setState({ isSearchMode: true, isSortMode: false }) }, void 0));
        return ((0, jsx_runtime_1.jsxs)(v2_1.default, Object.assign({ className: classes.searchBox }, { children: [multiSelectAction, !isSearchMode && sortAction, searchAction] }), void 0));
    }
}
exports.SearchBox = SearchBox;
SearchBox.defaultProps = {
    value: [],
    options: [],
    searchTerm: '',
    disabled: false,
    sortable: [],
};
exports.default = (0, withStyles_1.default)(MultiSelectFieldSearchBox_styles_1.default)(SearchBox);
//# sourceMappingURL=MultiSelectFieldSearchBox.js.map