"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SearchBox = exports.DEFAULT_SORT_MODE = exports.SortType = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const React = __importStar(require("react"));
const Close_1 = __importDefault(require("@material-ui/icons/Close"));
const Search_1 = __importDefault(require("@material-ui/icons/Search"));
const FilterList_1 = __importDefault(require("@material-ui/icons/FilterList"));
const SwapVert_1 = __importDefault(require("@material-ui/icons/SwapVert"));
const SwapVertReverse_1 = __importDefault(require("../../icons/SwapVertReverse"));
const withStyles_1 = __importDefault(require("../withStyles"));
const SearchBox_styles_1 = __importDefault(require("./SearchBox.styles"));
const Checkbox_1 = __importDefault(require("../Checkbox"));
const v2_1 = __importDefault(require("../ActionBar/v2"));
const helpers_1 = require("../../helpers");
var SortType;
(function (SortType) {
    SortType[SortType["Default"] = 0] = "Default";
    SortType[SortType["Name"] = 1] = "Name";
})(SortType = exports.SortType || (exports.SortType = {}));
exports.DEFAULT_SORT_MODE = {
    type: SortType.Default,
    isReverseSort: false,
};
class SearchBox extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            isSearchMode: false,
            isSortMode: false,
            sortMode: exports.DEFAULT_SORT_MODE,
        };
    }
    render() {
        const { value, options, searchTerm, onChange, onSearchChange, onSortChange, disabled, classes, } = this.props;
        const { isSearchMode, isSortMode, sortMode } = this.state;
        const numChecked = options
            .map((option) => (0, helpers_1.isElementSelected)(value, option))
            .filter((c) => c).length;
        const checked = options.length > 0 && numChecked === options.length;
        const indeterminate = options.length > 0 && numChecked > 0 && numChecked < options.length;
        const showingValue = options.map((option) => option.props.value);
        const multiSelectAction = ((0, jsx_runtime_1.jsx)(Checkbox_1.default, { className: classes.checkBox, disabled: disabled, checked: checked, indeterminate: indeterminate, onClick: (e) => {
                e.preventDefault();
                if (checked || indeterminate) {
                    onChange(value.filter((item) => !showingValue.includes(item)));
                }
                else {
                    const newValue = showingValue.filter((v) => !value.includes(v));
                    onChange([...value, ...newValue]);
                }
            } }, void 0));
        const isDefaultSortMode = sortMode.type === SortType.Default;
        const isDefaultSortModeRevert = isDefaultSortMode && sortMode.isReverseSort;
        const isNameSortMode = sortMode.type === SortType.Name;
        const isNameSortModeRevert = isNameSortMode && sortMode.isReverseSort;
        const sortActionOptions = ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(v2_1.default.SelectOption, { label: "Default", icon: isDefaultSortModeRevert ? (0, jsx_runtime_1.jsx)(SwapVertReverse_1.default, {}, void 0) : (0, jsx_runtime_1.jsx)(SwapVert_1.default, {}, void 0), selected: isDefaultSortMode, onClick: () => {
                        const newSortMode = {
                            type: SortType.Default,
                            isReverseSort: isDefaultSortMode
                                ? !sortMode.isReverseSort
                                : false,
                        };
                        this.setState({ isSortMode: !isSortMode, sortMode: newSortMode });
                        onSortChange(newSortMode);
                    } }, void 0), (0, jsx_runtime_1.jsx)(v2_1.default.SelectOption, { icon: isNameSortModeRevert ? (0, jsx_runtime_1.jsx)(SwapVertReverse_1.default, {}, void 0) : (0, jsx_runtime_1.jsx)(SwapVert_1.default, {}, void 0), label: "Name", selected: isNameSortMode, onClick: () => {
                        const newSortMode = {
                            type: SortType.Name,
                            isReverseSort: isNameSortMode ? !sortMode.isReverseSort : false,
                        };
                        this.setState({ isSortMode: !isSortMode, sortMode: newSortMode });
                        onSortChange(newSortMode);
                    } }, void 0)] }, void 0));
        const sortAction = ((0, jsx_runtime_1.jsx)(v2_1.default.Select, Object.assign({ icon: (0, jsx_runtime_1.jsx)(FilterList_1.default, { className: classes.sortIcon }, void 0), open: isSortMode, onOpen: () => this.setState(({ isSortMode: prevIsSortMode }) => ({
                isSortMode: !prevIsSortMode,
            })), disabled: disabled }, { children: sortActionOptions }), void 0));
        const searchAction = isSearchMode ? ((0, jsx_runtime_1.jsx)(v2_1.default.Input, { autoFocus: true, label: "Search", disabled: disabled, maxWidth: 145, className: classes.searchInput, icon: (0, jsx_runtime_1.jsx)(v2_1.default.Action, { icon: (0, jsx_runtime_1.jsx)(Close_1.default, { className: classes.closeIcon }, void 0), onClick: (e) => {
                    e.preventDefault();
                    this.setState({ isSearchMode: false });
                    onSearchChange('');
                } }, void 0), value: searchTerm, onChange: onSearchChange }, void 0)) : ((0, jsx_runtime_1.jsx)(v2_1.default.Action, { className: classes.searchInputWrapper, icon: (0, jsx_runtime_1.jsx)(Search_1.default, { className: classes.searchIcon }, void 0), disabled: disabled, onClick: () => this.setState({ isSearchMode: true, isSortMode: false }) }, void 0));
        return ((0, jsx_runtime_1.jsxs)(v2_1.default, Object.assign({ className: classes.searchBox }, { children: [multiSelectAction, !isSearchMode && sortAction, searchAction] }), void 0));
    }
}
exports.SearchBox = SearchBox;
SearchBox.defaultProps = {
    value: [],
    options: [],
    searchTerm: '',
    disabled: false,
};
exports.default = (0, withStyles_1.default)(SearchBox_styles_1.default)(SearchBox);
//# sourceMappingURL=SearchBox.js.map