"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PaperModal = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const Close_1 = __importDefault(require("@material-ui/icons/Close"));
const Paper_1 = __importDefault(require("@material-ui/core/Paper"));
const Grow_1 = __importDefault(require("@material-ui/core/Grow"));
const classnames_1 = __importDefault(require("classnames"));
const React = __importStar(require("react"));
const ReactDOM = __importStar(require("react-dom"));
const App_1 = require("../App");
const withThemeSelector_1 = __importDefault(require("../withThemeSelector"));
const Text_1 = __importDefault(require("../Text"));
const Spacer_1 = __importDefault(require("../../layout/Spacer"));
const Row_1 = __importDefault(require("../../layout/Row"));
const PaperModalBody_1 = __importDefault(require("./PaperModalBody"));
const PaperModalHeader_1 = __importDefault(require("./PaperModalHeader"));
const PaperModalFooter_1 = __importDefault(require("./PaperModalFooter"));
const PaperModalClose_1 = __importDefault(require("./PaperModalClose"));
const PaperModal_styles_1 = __importDefault(require("./PaperModal.styles"));
const PaperModal = (_a) => {
    var { elevation = 3, title, titleIcon, open, showClose = true, className, children, onClose = () => { } } = _a, paperModalProps = __rest(_a, ["elevation", "title", "titleIcon", "open", "showClose", "className", "children", "onClose"]);
    const classes = (0, PaperModal_styles_1.default)();
    const [animateOut, setAnimateOut] = React.useState(false);
    const isOpen = !animateOut && open;
    const { modalRoot } = React.useContext(App_1.AppContext);
    const closeModal = React.useCallback(() => {
        setAnimateOut(true);
    }, [setAnimateOut]);
    if (!modalRoot)
        return null;
    return ReactDOM.createPortal((0, jsx_runtime_1.jsx)(Grow_1.default, Object.assign({ in: isOpen, style: { transformOrigin: 'center bottom' }, onExited: () => {
            onClose();
            setAnimateOut(false);
        } }, { children: (0, jsx_runtime_1.jsxs)(Paper_1.default, Object.assign({ className: (0, classnames_1.default)(classes.root, className), elevation: elevation }, paperModalProps, { children: [(0, jsx_runtime_1.jsxs)("div", Object.assign({ className: classes.header }, { children: [(0, jsx_runtime_1.jsxs)(Row_1.default, Object.assign({ halfMargin: true, center: true, className: classes.title }, { children: [titleIcon && ((0, jsx_runtime_1.jsx)("span", Object.assign({ className: classes.titleIcon }, { children: titleIcon }), void 0)), title && ((0, jsx_runtime_1.jsx)(Text_1.default, Object.assign({ small: true, muted: true, ellipsis: true }, { children: title }), void 0))] }), void 0), (0, jsx_runtime_1.jsx)(Spacer_1.default, {}, void 0), showClose && ((0, jsx_runtime_1.jsxs)(PaperModalClose_1.default, Object.assign({ onClick: closeModal }, { children: [(0, jsx_runtime_1.jsx)(Close_1.default, {}, void 0), "Close"] }), void 0))] }), void 0), children] }), void 0) }), void 0), modalRoot);
};
exports.PaperModal = PaperModal;
exports.default = Object.assign((0, withThemeSelector_1.default)(exports.PaperModal), {
    Header: PaperModalHeader_1.default,
    Body: PaperModalBody_1.default,
    Footer: PaperModalFooter_1.default,
});
//# sourceMappingURL=PaperModal.js.map