"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PaperModalFooter = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const classnames_1 = __importDefault(require("classnames"));
const styles_1 = require("../../styles");
const mixins_1 = require("../../mixins");
const PaperModalFooter = ({ className, children, }) => {
    const classes = useStyles();
    return (0, jsx_runtime_1.jsx)("div", Object.assign({ className: (0, classnames_1.default)(classes.root, className) }, { children: children }), void 0);
};
exports.PaperModalFooter = PaperModalFooter;
const useStyles = (0, styles_1.makeStyles)((theme) => (0, styles_1.createStyles)({
    root: Object.assign(Object.assign({}, (0, mixins_1.marginBetweenChildrenHorizontal)(16)), { position: 'relative', display: 'flex', padding: theme.spacing(4, 0), margin: theme.spacing(0, 4), borderTop: `1px solid ${theme.divider.primary}`, [theme.breakpoints.down('xs')]: {
            margin: theme.spacing(0, 2),
        } }),
}));
exports.default = exports.PaperModalFooter;
//# sourceMappingURL=PaperModalFooter.js.map