"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Popover = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const classnames_1 = __importDefault(require("classnames"));
const Overlay_1 = __importDefault(require("../../internal/Overlay"));
const Hidden_1 = __importDefault(require("../../layout/Hidden"));
const withStyles_1 = __importDefault(require("../withStyles"));
const withThemeSelector_1 = __importDefault(require("../withThemeSelector"));
const Anchor_1 = __importDefault(require("./Anchor"));
const Body_1 = __importDefault(require("./Body"));
const Footer_1 = __importDefault(require("./Footer"));
const Header_1 = __importDefault(require("./Header"));
const Item_1 = __importDefault(require("./Item"));
const Popover_styles_1 = __importDefault(require("./Popover.styles"));
const PopoverPortal_1 = __importDefault(require("./PopoverPortal"));
const translations_1 = __importDefault(require("./translations"));
const Popover = ({ classes, open = false, anchor = ['top', 'left'], to = ['bottom', 'left'], width, height, onOverlayClick, children, }) => {
    if (!open)
        return null;
    const anchorY = anchor[0];
    const anchorX = anchor[1];
    const toY = to[0];
    const toX = to[1];
    const translate = translations_1.default[anchorY][anchorX][toY][toX];
    const className = (0, classnames_1.default)(classes.popover, width === 'auto' && classes.autoWidth, height === 'auto' && classes.autoHeight);
    return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(PopoverPortal_1.default, { children: (0, jsx_runtime_1.jsx)(Hidden_1.default, Object.assign({ mdUp: true }, { children: (0, jsx_runtime_1.jsxs)("div", Object.assign({ className: classes.popoverContainer }, { children: [(0, jsx_runtime_1.jsx)(Overlay_1.default, { onClick: onOverlayClick }, void 0), (0, jsx_runtime_1.jsx)("div", Object.assign({ className: className }, { children: children }), void 0)] }), void 0) }), void 0) }, void 0), (0, jsx_runtime_1.jsxs)(Hidden_1.default, Object.assign({ smDown: true }, { children: [(0, jsx_runtime_1.jsx)(Overlay_1.default, { className: classes.overlay, onClick: onOverlayClick }, void 0), (0, jsx_runtime_1.jsx)("div", Object.assign({ className: className, style: {
                            [toY]: -2,
                            [toX]: 0,
                            transform: `translate(${translate[0]}%, ${translate[1]}%)`,
                            width,
                        } }, { children: children }), void 0)] }), void 0)] }, void 0));
};
exports.Popover = Popover;
exports.default = Object.assign((0, withThemeSelector_1.default)((0, withStyles_1.default)(Popover_styles_1.default)(exports.Popover)), {
    Anchor: Anchor_1.default,
    Item: Item_1.default,
    Header: Header_1.default,
    Body: Body_1.default,
    Footer: Footer_1.default,
});
//# sourceMappingURL=Popover.js.map