"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RecurrenceSelector = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const styles_1 = require("@material-ui/core/styles");
const React = __importStar(require("react"));
const withStyles_1 = __importDefault(require("../../core/withStyles"));
const pluralize_1 = require("../../helpers/pluralize");
const Column_1 = __importDefault(require("../../layout/Column"));
const index_1 = __importDefault(require("../../layout/Row/index"));
const S = __importStar(require("../../sequence/sequenceTypes"));
const Text_1 = __importDefault(require("../../typography/Text"));
const SelectField_1 = __importDefault(require("../SelectField"));
const ToggleButtonGroup_1 = __importDefault(require("../ToggleButtonGroup"));
const generateArrayRange = (start, end) => {
    const length = end - start + 1;
    return Array.from(Array(length).keys(), (x) => x + start);
};
const frequencies = {
    [S.Frequency.weekly]: {
        label: 'week',
        intervals: generateArrayRange(1, 10),
    },
    [S.Frequency.monthly]: {
        label: 'month',
        intervals: generateArrayRange(1, 12),
    },
};
const monthDayOptions = generateArrayRange(1, 31);
const initialValues = {
    dtstart: '',
    freq: S.Frequency.weekly,
    interval: 1,
    byday: [],
    bymonthday: [],
};
class RecurrenceSelector extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            recurrenceRule: Object.assign(Object.assign({}, initialValues), this.props.recurrenceRule),
        };
        this.updateRecurrenceRule = (recurrenceRule) => {
            const updatedRecurrenceRule = Object.assign(Object.assign({}, this.state.recurrenceRule), recurrenceRule);
            this.setState({
                recurrenceRule: updatedRecurrenceRule,
            });
            if (this.props.onChange) {
                this.props.onChange(updatedRecurrenceRule);
            }
        };
        this.handleFrequencyChange = (value) => {
            this.setState({
                recurrenceRule: Object.assign(Object.assign({}, this.state.recurrenceRule), { freq: value, 
                    // reset form values when frequency changes
                    interval: initialValues.interval, byday: initialValues.byday, bymonthday: initialValues.bymonthday }),
            }, () => {
                if (this.props.onChange) {
                    this.props.onChange(this.state.recurrenceRule);
                }
            });
        };
    }
    render() {
        const { recurrenceRule } = this.state;
        const { freq, interval, bymonthday, byday } = recurrenceRule;
        const { classes, testId } = this.props;
        return ((0, jsx_runtime_1.jsxs)(Column_1.default, { children: [(0, jsx_runtime_1.jsx)(Text_1.default, Object.assign({ bold: true, small: true }, { children: "REPEAT EVERY" }), void 0), (0, jsx_runtime_1.jsxs)(index_1.default, { children: [(0, jsx_runtime_1.jsx)("div", Object.assign({ className: classes.intervalSelector }, { children: (0, jsx_runtime_1.jsx)(SelectField_1.default, Object.assign({ value: String(interval), onChange: (value) => this.updateRecurrenceRule({ interval: parseInt(value, 10) }), testId: `${testId}-interval` }, { children: frequencies[freq].intervals.map((o) => ((0, jsx_runtime_1.jsx)("option", Object.assign({ value: o }, { children: o }), o))) }), void 0) }), void 0), (0, jsx_runtime_1.jsx)("div", Object.assign({ className: classes.frequencySelector }, { children: (0, jsx_runtime_1.jsx)(SelectField_1.default, Object.assign({ value: freq, onChange: (value) => {
                                    this.handleFrequencyChange(value);
                                }, testId: `${testId}-frequency` }, { children: Object.entries(frequencies).map(([k, { label }]) => ((0, jsx_runtime_1.jsx)("option", Object.assign({ value: k }, { children: (0, pluralize_1.pluralize)(label, interval) }), k))) }), void 0) }), void 0)] }, void 0), (0, jsx_runtime_1.jsx)(Text_1.default, Object.assign({ bold: true, small: true }, { children: "ON" }), void 0), (0, jsx_runtime_1.jsxs)("div", { children: [freq === S.Frequency.monthly && ((0, jsx_runtime_1.jsxs)(SelectField_1.default, Object.assign({ label: "Day", value: bymonthday ? String(bymonthday[0]) : '', onChange: (value) => this.updateRecurrenceRule({
                                bymonthday: value ? [parseInt(value, 10)] : [],
                            }), testId: `${testId}-bymonthday` }, { children: [(0, jsx_runtime_1.jsx)("option", Object.assign({ value: "" }, { children: "Use start date" }), "Use start date"), monthDayOptions.map((v) => ((0, jsx_runtime_1.jsx)("option", Object.assign({ value: v }, { children: v }), v))), (0, jsx_runtime_1.jsx)("option", Object.assign({ value: -1 }, { children: "Last" }), "Last")] }), void 0)), freq === S.Frequency.weekly && ((0, jsx_runtime_1.jsx)(ToggleButtonGroup_1.default, Object.assign({ value: byday, onChange: (value) => this.updateRecurrenceRule({
                                byday: value,
                            }) }, { children: Object.entries(S.DaysOfWeek).map(([value, label]) => ((0, jsx_runtime_1.jsx)(ToggleButtonGroup_1.default.Button, Object.assign({ value: value }, { children: label }), value))) }), void 0))] }, void 0)] }, void 0));
    }
}
exports.RecurrenceSelector = RecurrenceSelector;
const styles = () => (0, styles_1.createStyles)({
    frequencySelector: {
        flex: 7,
    },
    intervalSelector: {
        flex: 3,
    },
});
exports.default = (0, withStyles_1.default)(styles)(RecurrenceSelector);
//# sourceMappingURL=RecurrenceSelector.js.map