"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const mixins_1 = require("../../mixins");
const withStyles_1 = require("../withStyles");
const styles = (theme) => (0, withStyles_1.createStyles)({
    root: Object.assign({ flex: 1, position: 'relative' }, (0, mixins_1.tab)(theme)),
    shrink: {
        flexGrow: 0,
    },
    active: {
        fontWeight: 500,
        '&:after': {
            content: '" "',
            position: 'absolute',
            bottom: -1,
            height: 3,
            width: '100%',
            backgroundColor: theme.tab.activeBorder,
        },
    },
    icon: {
        color: theme.tab.foreground,
        margin: `${theme.spacing(1)}px auto`,
    },
    label: {
        color: theme.tab.foreground,
        fontSize: theme.fontSizes.sm,
        fontWeight: 500,
        textAlign: 'center',
        whiteSpace: 'nowrap',
    },
    labelNoIcon: {
        fontSize: theme.fontSizes.md,
        fontWeight: 400,
        '$active &': {
            fontWeight: 500,
        },
    },
});
exports.default = styles;
//# sourceMappingURL=TabItem.styles.js.map