"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ThemeSelector = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const styles_1 = require("@material-ui/core/styles");
const ThemeProvider_1 = require("../ThemeProvider");
const ThemeSelector = ({ color, children }) => {
    // If color isn't provided, render children without selecting a theme.
    // This allows components to inherit the parent theme when not set.
    if (!color)
        return (0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: children }, void 0);
    return ((0, jsx_runtime_1.jsx)(ThemeProvider_1.ThemeContext.Consumer, { children: (themeContext) => {
            if (!themeContext)
                return;
            return ((0, jsx_runtime_1.jsx)(styles_1.ThemeProvider, Object.assign({ theme: themeContext.theme[color] }, { children: children }), void 0));
        } }, void 0));
};
exports.ThemeSelector = ThemeSelector;
exports.default = exports.ThemeSelector;
//# sourceMappingURL=ThemeSelector.js.map