"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const ThemeSelector_1 = __importDefault(require("./ThemeSelector"));
function withThemeSelector(Component, 
// The default color to use when props.color isn't provided. If this isn't set
// it will inherit the current color from context.
defaultColor) {
    const WrappedComponent = (props) => {
        if (!props.color && !defaultColor)
            return (0, jsx_runtime_1.jsx)(Component, Object.assign({}, props), void 0);
        return ((0, jsx_runtime_1.jsx)(ThemeSelector_1.default, Object.assign({ color: props.color || defaultColor }, { children: (0, jsx_runtime_1.jsx)(Component, Object.assign({}, props), void 0) }), void 0));
    };
    return WrappedComponent;
}
exports.default = withThemeSelector;
//# sourceMappingURL=withThemeSelector.js.map