"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AddDevice = exports.AddDeviceMinHeight = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const React = __importStar(require("react"));
const react_media_1 = __importDefault(require("react-media"));
const Button_1 = __importDefault(require("../../core/Button"));
const Form_1 = __importDefault(require("../../core/Form"));
const RadioGroup_1 = __importDefault(require("../../core/RadioGroup"));
const TextField_1 = __importDefault(require("../../core/TextField"));
const withStyles_1 = __importStar(require("../../core/withStyles"));
const Column_1 = __importDefault(require("../../layout/Column"));
exports.AddDeviceMinHeight = 400;
const heightUpBp = `@media screen and (min-height: ${exports.AddDeviceMinHeight}px)`;
const styles = (theme) => (0, withStyles_1.createStyles)({
    root: {
        display: 'flex',
        alignItems: 'center',
        width: '100%',
        [heightUpBp]: {
            flexDirection: 'column',
            maxWidth: 400,
        },
    },
    cta: {
        display: 'flex',
        flexDirection: 'column',
        alignItems: 'center',
        paddingRight: theme.spacing(2),
        [heightUpBp]: {
            paddingRight: 0,
            marginBottom: theme.spacing(2),
        },
    },
    form: {
        width: '100%',
        minWidth: 240,
        [heightUpBp]: {
            minWidth: 'none',
        },
    },
    subHeading: {
        fontWeight: 500,
        fontSize: theme.fontSizes.lg,
        whiteSpace: 'nowrap',
    },
    heading: {
        fontSize: theme.fontSizes.lg,
    },
    screen: {
        backgroundColor: '#292834',
        fontSize: theme.fontSizes.lg,
        color: 'white',
        display: 'flex',
        marginLeft: 'auto',
        marginRight: 'auto',
        alignItems: 'center',
        justifyContent: 'center',
        width: '192px',
        height: '108px',
        boxShadow: theme.shadows[1],
    },
    audioOnly: {
        display: 'flex',
        flexDirection: 'row',
        alignItems: 'center',
        justifyContent: 'center',
    },
    audioOnlyLabel: {
        marginRight: theme.spacing(2),
    },
});
class AddDevice extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            activationCode: '',
            name: '',
            isAudioOnly: false,
        };
        this.handleSubmitRegisterDeviceForm = () => {
            const { onRegister } = this.props;
            const { activationCode, name, isAudioOnly } = this.state;
            onRegister({ activationCode, name, isAudioOnly });
        };
    }
    renderAudioOnly() {
        const { classes, testId, hideAudioOnly } = this.props;
        const { isAudioOnly } = this.state;
        if (hideAudioOnly)
            return null;
        return ((0, jsx_runtime_1.jsxs)("div", Object.assign({ className: classes.audioOnly }, { children: [(0, jsx_runtime_1.jsx)("span", Object.assign({ className: classes.audioOnlyLabel }, { children: "Is this an audio-only device?" }), void 0), (0, jsx_runtime_1.jsxs)(RadioGroup_1.default, Object.assign({ inline: true, value: isAudioOnly ? 'yes' : 'no', onChange: (value) => this.setState({ isAudioOnly: value === 'yes' }), testId: `${testId}-audio-only` }, { children: [(0, jsx_runtime_1.jsx)(RadioGroup_1.default.Option, { value: "yes", label: "Yes", testId: `${testId}-audio-only-yes` }, void 0), (0, jsx_runtime_1.jsx)(RadioGroup_1.default.Option, { value: "no", label: "No", testId: `${testId}-audio-only-no` }, void 0)] }), void 0)] }), void 0));
    }
    render() {
        const { classes, headingText, loading, error, testId } = this.props;
        const { activationCode, name } = this.state;
        return ((0, jsx_runtime_1.jsxs)("div", Object.assign({ className: classes.root }, { children: [(0, jsx_runtime_1.jsxs)(Column_1.default, Object.assign({ className: classes.cta }, { children: [(0, jsx_runtime_1.jsx)("span", Object.assign({ className: classes.heading }, { children: headingText }), void 0), (0, jsx_runtime_1.jsx)(react_media_1.default, Object.assign({ query: `(min-height: ${exports.AddDeviceMinHeight}px)` }, { children: (matches) => (matches ? this.renderAudioOnly() : null) }), void 0), (0, jsx_runtime_1.jsx)("div", Object.assign({ className: classes.screen }, { children: (0, jsx_runtime_1.jsx)("span", { children: "WORD 1 - WORD 2" }, void 0) }), void 0), (0, jsx_runtime_1.jsx)("div", Object.assign({ className: classes.subHeading }, { children: "Enter the code shown on your TV" }), void 0)] }), void 0), (0, jsx_runtime_1.jsx)(Form_1.default, Object.assign({ className: classes.form, onSubmit: this.handleSubmitRegisterDeviceForm }, { children: (0, jsx_runtime_1.jsxs)(Column_1.default, { children: [(0, jsx_runtime_1.jsx)(react_media_1.default, Object.assign({ query: `(min-height: ${exports.AddDeviceMinHeight}px)` }, { children: (matches) => (matches ? null : this.renderAudioOnly()) }), void 0), (0, jsx_runtime_1.jsx)(TextField_1.default, { label: "Activation Code", value: activationCode, onChange: (value) => this.setState({ activationCode: value }), error: !!error, helperText: error, mask: (value = '') => value.split('').map(() => /[a-zA-Z\-\s]/g), pipe: (value = '') => {
                                    const newValue = value.toUpperCase().replace(' ', '-');
                                    return {
                                        value: newValue,
                                        indexesOfPipedChars: [newValue.indexOf('-') - 1],
                                    };
                                }, testId: `${testId}-activation-code` }, void 0), (0, jsx_runtime_1.jsx)(TextField_1.default, { label: "Name (Optional)", value: name, onChange: (value) => this.setState({ name: value }), testId: `${testId}-name` }, void 0), (0, jsx_runtime_1.jsx)(Button_1.default, { type: "submit", label: "Activate", color: "progress", disabled: !activationCode.match(/^[A-Z]+-[A-Z]+$/) || loading, testId: `${testId}-submit` }, void 0)] }, void 0) }), void 0)] }), void 0));
    }
}
exports.AddDevice = AddDevice;
exports.default = (0, withStyles_1.default)(styles)(AddDevice);
//# sourceMappingURL=AddDevice.js.map