"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AffectedDevicesPopover = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const Error_1 = __importDefault(require("@material-ui/icons/Error"));
const Button_1 = __importDefault(require("../../core/Button"));
const Popover_1 = __importDefault(require("../../core/Popover"));
const withStyles_1 = __importStar(require("../../core/withStyles"));
const Hidden_1 = __importDefault(require("../../layout/Hidden"));
const Spacer_1 = __importDefault(require("../../layout/Spacer"));
const Row_1 = __importDefault(require("../../layout/Row"));
const Text_1 = __importDefault(require("../../typography/Text"));
const styles = (theme) => (0, withStyles_1.createStyles)({
    warning: {
        display: 'flex',
        fontSize: theme.fontSizes.sm,
        marginRight: theme.spacing(1),
        lineHeight: 1.5,
    },
    icon: {
        color: theme.palette.warning.main,
        backgroundColor: theme.palette.primary.main,
        borderRadius: 100,
    },
});
const AffectedDevicesPopover = ({ devices = [], open, onClose, testId, classes, }) => {
    const screensText = devices.length === 1 ? 'this screen' : 'these screens';
    return ((0, jsx_runtime_1.jsxs)(Popover_1.default, Object.assign({ anchor: ['bottom', 'left'], to: ['top', 'left'], open: open, onOverlayClick: onClose }, { children: [(0, jsx_runtime_1.jsx)(Popover_1.default.Header, { children: (0, jsx_runtime_1.jsxs)(Row_1.default, Object.assign({ halfMargin: true }, { children: [(0, jsx_runtime_1.jsx)(Error_1.default, { className: classes.icon }, void 0), (0, jsx_runtime_1.jsxs)(Text_1.default, Object.assign({ small: true }, { children: ["Saving these changes will overwrite content on ", screensText] }), void 0), (0, jsx_runtime_1.jsx)(Hidden_1.default, Object.assign({ smDown: true }, { children: (0, jsx_runtime_1.jsx)(Button_1.default, { label: "Got it", onClick: onClose, testId: testId ? `${testId}-ok` : '' }, void 0) }), void 0)] }), void 0) }, void 0), (0, jsx_runtime_1.jsx)(Popover_1.default.Body, { children: devices.map((device) => ((0, jsx_runtime_1.jsx)(Popover_1.default.Item, { children: device.name }, device.id))) }, void 0), (0, jsx_runtime_1.jsx)(Hidden_1.default, Object.assign({ mdUp: true }, { children: (0, jsx_runtime_1.jsxs)(Popover_1.default.Footer, { children: [(0, jsx_runtime_1.jsx)(Spacer_1.default, {}, void 0), (0, jsx_runtime_1.jsx)(Button_1.default, { label: "Got it", onClick: onClose, testId: testId ? `${testId}-ok` : '' }, void 0)] }, void 0) }), void 0)] }), void 0));
};
exports.AffectedDevicesPopover = AffectedDevicesPopover;
exports.default = (0, withStyles_1.default)(styles)(exports.AffectedDevicesPopover);
//# sourceMappingURL=AffectedDevicesPopover.js.map