"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const Icon_1 = __importDefault(require("../../core/Icon"));
const SVGIcon_1 = __importDefault(require("../../core/SVGIcon"));
const withStyles_1 = __importDefault(require("../../core/withStyles"));
const ConnectionIndicator_styles_1 = __importDefault(require("./ConnectionIndicator.styles"));
const ConnectionIndicator = ({ signalStrength, isEthernet, isLTE, classes }) => {
    if (isEthernet) {
        return (0, jsx_runtime_1.jsx)(SVGIcon_1.default, { className: classes.root, icon: "ethernet" }, void 0);
    }
    if (!signalStrength) {
        return (0, jsx_runtime_1.jsx)(SVGIcon_1.default, { icon: "wifiNone" }, void 0);
    }
    if (isLTE) {
        if (signalStrength > 80) {
            return (0, jsx_runtime_1.jsx)(Icon_1.default, { className: classes.root, icon: "lteFull" }, void 0);
        }
        if (signalStrength > 40) {
            return (0, jsx_runtime_1.jsx)(Icon_1.default, { className: classes.root, icon: "lteMedium" }, void 0);
        }
        if (signalStrength > 0) {
            return (0, jsx_runtime_1.jsx)(Icon_1.default, { className: classes.root, icon: "lteLow" }, void 0);
        }
        if (signalStrength === 0) {
            return (0, jsx_runtime_1.jsx)(Icon_1.default, { className: classes.root, icon: "lteNone" }, void 0);
        }
    }
    if (signalStrength > 80) {
        return (0, jsx_runtime_1.jsx)(SVGIcon_1.default, { className: classes.root, icon: "wifiFull" }, void 0);
    }
    if (signalStrength > 50) {
        return (0, jsx_runtime_1.jsx)(SVGIcon_1.default, { className: classes.root, icon: "wifiHigh" }, void 0);
    }
    if (signalStrength > 20) {
        return (0, jsx_runtime_1.jsx)(SVGIcon_1.default, { className: classes.root, icon: "wifiMedium" }, void 0);
    }
    if (signalStrength > 0) {
        return (0, jsx_runtime_1.jsx)(SVGIcon_1.default, { className: classes.root, icon: "wifiLow" }, void 0);
    }
    if (signalStrength === 0) {
        return (0, jsx_runtime_1.jsx)(SVGIcon_1.default, { className: classes.root, icon: "wifiNone" }, void 0);
    }
    // TODO: Unknown connection status, possibly still fetching or failed.
    // Consider showing a loading indicator.
    return (0, jsx_runtime_1.jsx)(SVGIcon_1.default, { icon: "wifiNone" }, void 0);
};
exports.default = (0, withStyles_1.default)(ConnectionIndicator_styles_1.default)(ConnectionIndicator);
//# sourceMappingURL=ConnectionIndicator.js.map