"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const Button_1 = __importDefault(require("../../core/Button"));
const withStyles_1 = __importDefault(require("../../core/withStyles"));
const helpers_1 = require("../../helpers");
const Hidden_1 = __importDefault(require("../../layout/Hidden"));
const Row_1 = __importDefault(require("../../layout/Row"));
const DeviceListConnectionStatus_1 = __importDefault(require("./DeviceListConnectionStatus"));
const DeviceListDevice_styles_1 = __importDefault(require("./DeviceListDevice.styles"));
const audioDeviceThumbnailURL = 'https://assets.raydiant.com/images/audio-device-thumbnail.svg';
const DeviceListAudioDevice = ({ classes, device, signalStrength, isOnline, isEthernet, isLTE, onConnectivityWizard, onSettings, onClick, }) => {
    return ((0, jsx_runtime_1.jsxs)(Row_1.default, Object.assign({ className: classes.root, center: true, onClick: onClick }, { children: [(0, jsx_runtime_1.jsxs)(Row_1.default, Object.assign({ className: classes.deviceInfo, center: true }, { children: [(0, jsx_runtime_1.jsx)(Hidden_1.default, Object.assign({ smDown: true }, { children: (0, jsx_runtime_1.jsx)("div", { style: { backgroundImage: `url(${audioDeviceThumbnailURL})` }, className: classes.thumbnail }, void 0) }), void 0), (0, jsx_runtime_1.jsxs)("div", { children: [(0, jsx_runtime_1.jsxs)("div", Object.assign({ className: classes.name }, { children: [device.name, " [audio mode]"] }), void 0), (0, jsx_runtime_1.jsx)(DeviceListConnectionStatus_1.default, { device: device, signalStrength: signalStrength, isOnline: isOnline, isEthernet: isEthernet, isLTE: isLTE, onConnectivityWizard: onConnectivityWizard }, void 0)] }, void 0)] }), void 0), (0, jsx_runtime_1.jsx)(Row_1.default, Object.assign({ className: classes.deviceActions, center: true }, { children: onSettings && ((0, jsx_runtime_1.jsx)(Button_1.default, { icon: "settings", hideBorder: true, onClick: (0, helpers_1.stopPropagation)(onSettings) }, void 0)) }), void 0)] }), void 0));
};
exports.default = (0, withStyles_1.default)(DeviceListDevice_styles_1.default)(DeviceListAudioDevice);
//# sourceMappingURL=DeviceListAudioDevice.js.map