"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeviceListDevice = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const Button_1 = __importDefault(require("../../core/Button"));
const withStyles_1 = __importDefault(require("../../core/withStyles"));
const helpers_1 = require("../../helpers");
const Column_1 = __importDefault(require("../../layout/Column"));
const Hidden_1 = __importDefault(require("../../layout/Hidden"));
const Row_1 = __importDefault(require("../../layout/Row"));
const Spacer_1 = __importDefault(require("../../layout/Spacer"));
const DeviceListConnectionStatus_1 = __importDefault(require("./DeviceListConnectionStatus"));
const DeviceListDevice_styles_1 = __importDefault(require("./DeviceListDevice.styles"));
const DeviceListPlaylistSelector_1 = __importDefault(require("./DeviceListPlaylistSelector"));
const DeviceListDeviceMobile = ({ classes, device, playlistsByOwner, currentUserProfileId, signalStrength, isOnline, isEthernet, isLTE, needsPublish, disablePublish, onSelectPlaylist, onEditPlaylist, onCreatePlaylist, onPublish, onConnectivityWizard, onSettings, }) => {
    return ((0, jsx_runtime_1.jsxs)(Column_1.default, Object.assign({ className: classes.root }, { children: [(0, jsx_runtime_1.jsxs)(Row_1.default, Object.assign({ center: true }, { children: [(0, jsx_runtime_1.jsx)("div", Object.assign({ className: classes.name }, { children: device.name }), void 0), (0, jsx_runtime_1.jsx)(Spacer_1.default, {}, void 0), onSettings && ((0, jsx_runtime_1.jsx)(Button_1.default, { icon: "settings", hideBorder: true, onClick: onSettings }, void 0))] }), void 0), (0, jsx_runtime_1.jsxs)(Row_1.default, Object.assign({ center: true }, { children: [(0, jsx_runtime_1.jsx)(DeviceListPlaylistSelector_1.default
                    // @ts-ignore
                    , { 
                        // @ts-ignore
                        value: device.playlistId, playlistsByOwner: playlistsByOwner, currentUserProfileId: currentUserProfileId, onSelectPlaylist: onSelectPlaylist, onEditPlaylist: onEditPlaylist, onCreatePlaylist: onCreatePlaylist }, void 0), needsPublish && onPublish && ((0, jsx_runtime_1.jsx)(Button_1.default, { color: "progress", icon: "publish", disabled: disablePublish, onClick: onPublish }, void 0))] }), void 0), (0, jsx_runtime_1.jsx)(DeviceListConnectionStatus_1.default, { device: device, signalStrength: signalStrength, isOnline: isOnline, isEthernet: isEthernet, isLTE: isLTE, onConnectivityWizard: onConnectivityWizard }, void 0)] }), void 0));
};
const DeviceListDeviceDesktop = ({ classes, device, playlistsByOwner, currentUserProfileId, thumbnail, signalStrength, isOnline, isEthernet, isLTE, needsPublish, disablePublish, onSelectPlaylist, onEditPlaylist, onCreatePlaylist, onPublish, onConnectivityWizard, onSettings, onClick, }) => {
    return ((0, jsx_runtime_1.jsxs)(Row_1.default, Object.assign({ className: classes.root, center: true, onClick: onClick }, { children: [(0, jsx_runtime_1.jsxs)(Row_1.default, Object.assign({ className: classes.deviceInfo, center: true }, { children: [(0, jsx_runtime_1.jsx)(Hidden_1.default, Object.assign({ smDown: true }, { children: (0, jsx_runtime_1.jsx)("div", { style: { backgroundImage: thumbnail ? `url(${thumbnail})` : '' }, className: classes.thumbnail }, void 0) }), void 0), (0, jsx_runtime_1.jsxs)("div", { children: [(0, jsx_runtime_1.jsx)("div", Object.assign({ className: classes.name }, { children: device.name }), void 0), (0, jsx_runtime_1.jsx)(DeviceListConnectionStatus_1.default, { device: device, signalStrength: signalStrength, isOnline: isOnline, isEthernet: isEthernet, isLTE: isLTE, onConnectivityWizard: onConnectivityWizard }, void 0)] }, void 0)] }), void 0), (0, jsx_runtime_1.jsx)(DeviceListPlaylistSelector_1.default
            // @ts-ignore
            , { 
                // @ts-ignore
                value: device.playlistId, playlistsByOwner: playlistsByOwner, currentUserProfileId: currentUserProfileId, onSelectPlaylist: onSelectPlaylist, onEditPlaylist: onEditPlaylist, onCreatePlaylist: onCreatePlaylist }, void 0), (0, jsx_runtime_1.jsxs)(Row_1.default, Object.assign({ className: classes.deviceActions, center: true }, { children: [needsPublish && onPublish && ((0, jsx_runtime_1.jsx)(Button_1.default, { color: "progress", icon: "publish", label: "Publish", disabled: disablePublish, onClick: (0, helpers_1.stopPropagation)(onPublish) }, void 0)), onSettings && ((0, jsx_runtime_1.jsx)(Button_1.default, { icon: "settings", hideBorder: true, onClick: (0, helpers_1.stopPropagation)(onSettings) }, void 0))] }), void 0)] }), void 0));
};
const DeviceListDevice = (props) => ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(Hidden_1.default, Object.assign({ xsDown: true }, { children: (0, jsx_runtime_1.jsx)(DeviceListDeviceDesktop, Object.assign({}, props), void 0) }), void 0), (0, jsx_runtime_1.jsx)(Hidden_1.default, Object.assign({ smUp: true }, { children: (0, jsx_runtime_1.jsx)(DeviceListDeviceMobile, Object.assign({}, props), void 0) }), void 0)] }, void 0));
exports.DeviceListDevice = DeviceListDevice;
exports.default = (0, withStyles_1.default)(DeviceListDevice_styles_1.default)(exports.DeviceListDevice);
//# sourceMappingURL=DeviceListDevice.js.map