"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const Input_1 = __importDefault(require("@material-ui/core/Input"));
const classnames_1 = __importDefault(require("classnames"));
const withStyles_1 = __importDefault(require("../../core/withStyles"));
const Input_styles_1 = __importDefault(require("./Input.styles"));
const Input = ({ value = '', type = 'text', placeholder = '', fullWidth = false, disabled = false, multiline = false, multilineHeight, icon, inputProps, inputComponent, onChange, onKeyUp, onKeyDown, onBlur, onFocus, classes, inputRef, }) => {
    let multilineOpts = {};
    let multilineInputOpts = {};
    if (multiline) {
        multilineOpts = {
            rows: 4,
            rowsMax: 4,
            multiline: true,
        };
        multilineInputOpts = { style: { height: multilineHeight } };
    }
    const inputElement = ((0, jsx_runtime_1.jsx)(Input_1.default, Object.assign({ inputRef: inputRef, value: value, type: type, placeholder: placeholder, fullWidth: fullWidth, disabled: disabled, inputComponent: inputComponent, onChange: onChange, onKeyUp: onKeyUp, onKeyDown: onKeyDown, onBlur: onBlur, onFocus: onFocus, classes: {
            root: classes.root,
            multiline: classes.multiline,
            underline: classes.underline,
            disabled: classes.disabled,
            input: (0, classnames_1.default)(classes.input, icon && classes.inputWithIcon, multiline && classes.inputWithMultiline),
        }, inputProps: Object.assign(Object.assign({}, inputProps), multilineInputOpts) }, multilineOpts), void 0));
    if (icon) {
        return ((0, jsx_runtime_1.jsxs)("div", Object.assign({ className: classes.iconContainer }, { children: [inputElement, (0, jsx_runtime_1.jsx)("div", Object.assign({ className: classes.icon }, { children: icon }), void 0)] }), void 0));
    }
    return inputElement;
};
exports.default = (0, withStyles_1.default)(Input_styles_1.default)(Input);
//# sourceMappingURL=Input.js.map