"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const React = __importStar(require("react"));
const stateChanged_1 = __importDefault(require("../../helpers/stateChanged"));
const withScrollConsumer_1 = __importDefault(require("./withScrollConsumer"));
const withVisibility = (Component) => {
    class ComponentWithVisibility extends React.Component {
        constructor() {
            super(...arguments);
            this.ref = React.createRef();
            this.state = {
                isTopVisible: false,
                isBottomVisible: false,
                isLeftVisible: false,
                isRightVisible: false,
                isFullyVisible: false,
                isPartiallyVisible: false,
                isNotVisible: false,
            };
        }
        computeVisibilityProps() {
            const { scrollTop = 0, scrollLeft = 0, offsetWidth = 0, offsetHeight = 0, } = this.props;
            const containerBounds = {
                top: scrollTop,
                bottom: scrollTop + offsetHeight,
                left: scrollLeft,
                right: scrollLeft + offsetWidth,
            };
            const { offsetTop = 0, offsetLeft = 0, scrollWidth = 0, scrollHeight = 0, } = this.ref.current || {};
            const elementBounds = {
                top: offsetTop,
                bottom: offsetTop + scrollHeight,
                left: offsetLeft,
                right: offsetLeft + scrollWidth,
            };
            const isAboveVisibleArea = elementBounds.bottom < containerBounds.top;
            const isBelowVisibleArea = elementBounds.top > containerBounds.bottom;
            const isLeftOfVisibleArea = elementBounds.right < containerBounds.left;
            const isRightOfVisibleArea = elementBounds.left > containerBounds.right;
            const isNotVisible = isAboveVisibleArea ||
                isBelowVisibleArea ||
                isLeftOfVisibleArea ||
                isRightOfVisibleArea;
            const isPartiallyVisible = !isNotVisible;
            const isHorizontallyOutOfBounds = isLeftOfVisibleArea || isRightOfVisibleArea;
            const isVerticallyOutOfBounds = isAboveVisibleArea || isBelowVisibleArea;
            const isTopVisible = !isBelowVisibleArea &&
                !isHorizontallyOutOfBounds &&
                elementBounds.top >= containerBounds.top;
            const isBottomVisible = !isAboveVisibleArea &&
                !isHorizontallyOutOfBounds &&
                elementBounds.bottom <= containerBounds.bottom;
            const isLeftVisible = !isRightOfVisibleArea &&
                !isVerticallyOutOfBounds &&
                elementBounds.left >= containerBounds.left;
            const isRightVisible = !isLeftOfVisibleArea &&
                !isVerticallyOutOfBounds &&
                elementBounds.right <= containerBounds.right;
            const isFullyVisible = isTopVisible && isBottomVisible && isLeftVisible && isRightVisible;
            const state = {
                isTopVisible,
                isBottomVisible,
                isLeftVisible,
                isRightVisible,
                isFullyVisible,
                isPartiallyVisible,
                isNotVisible,
            };
            if ((0, stateChanged_1.default)(state, this.state))
                this.setState(state);
        }
        componentDidMount() {
            this.computeVisibilityProps();
        }
        componentDidUpdate() {
            this.computeVisibilityProps();
        }
        render() {
            const { isTopVisible, isLeftVisible, isRightVisible, isBottomVisible, isFullyVisible, isPartiallyVisible, isNotVisible, } = this.state;
            return ((0, jsx_runtime_1.jsx)(Component, Object.assign({ isTopVisible: isTopVisible, isLeftVisible: isLeftVisible, isRightVisible: isRightVisible, isBottomVisible: isBottomVisible, isPartiallyVisible: isPartiallyVisible, isFullyVisible: isFullyVisible, isNotVisible: isNotVisible, visibleElementRef: this.ref }, this.props), void 0));
        }
    }
    return (0, withScrollConsumer_1.default)(ComponentWithVisibility);
};
exports.default = withVisibility;
//# sourceMappingURL=withVisibility.js.map