"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Scrollable = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const classnames_1 = __importDefault(require("classnames"));
const withStyles_1 = __importStar(require("../../core/withStyles"));
const mixins_1 = require("../../mixins");
const ScrollableContext_1 = __importDefault(require("./ScrollableContext"));
const ScrollableVisibilitySensor_1 = __importDefault(require("./ScrollableVisibilitySensor"));
const ScrollableShadow_1 = __importDefault(require("./ScrollableShadow"));
const useVisibilityContainer_1 = __importDefault(require("./useVisibilityContainer"));
const styles = (_) => (0, withStyles_1.createStyles)({
    root: {
        flex: 1,
        position: 'relative',
        overflow: 'hidden',
        display: 'flex',
        flexDirection: 'column',
    },
    scroll: Object.assign({ display: 'flex', flexDirection: 'column', flex: 1 }, (0, mixins_1.scrollable)()),
});
const Scrollable = ({ className, shadowClassName, buffer, children, classes, }) => {
    const { containerRef, addRefToVisibilbityMap, removeRefFromVisibilbityMap } = (0, useVisibilityContainer_1.default)({ buffer });
    return ((0, jsx_runtime_1.jsx)(ScrollableContext_1.default.Provider, Object.assign({ value: {
            scrollRef: containerRef,
            addRefToVisibilbityMap: addRefToVisibilbityMap,
            removeRefFromVisibilbityMap: removeRefFromVisibilbityMap,
        } }, { children: (0, jsx_runtime_1.jsxs)("div", Object.assign({ className: (0, classnames_1.default)(classes.root, className) }, { children: [(0, jsx_runtime_1.jsx)(ScrollableShadow_1.default, { scrollRef: containerRef, position: "top", className: shadowClassName }, void 0), (0, jsx_runtime_1.jsx)("div", Object.assign({ ref: containerRef, className: classes.scroll }, { children: typeof children === 'function'
                        ? children(containerRef)
                        : children }), void 0), (0, jsx_runtime_1.jsx)(ScrollableShadow_1.default, { scrollRef: containerRef, position: "bottom", className: shadowClassName }, void 0)] }), void 0) }), void 0));
};
exports.Scrollable = Scrollable;
exports.default = Object.assign((0, withStyles_1.default)(styles)(exports.Scrollable), {
    VisibilitySensor: ScrollableVisibilitySensor_1.default,
});
//# sourceMappingURL=Scrollable.js.map