"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScrollableShadow = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const classnames_1 = __importDefault(require("classnames"));
const React = __importStar(require("react"));
const withStyles_1 = __importStar(require("../../core/withStyles"));
const shadowHeight = 20;
const styles = (theme) => (0, withStyles_1.createStyles)({
    root: {
        position: 'absolute',
        pointerEvents: 'none',
        zIndex: theme.zIndex.shadow,
        left: 0,
        right: 0,
        height: shadowHeight,
    },
    top: {
        top: -shadowHeight,
        opacity: 0.5,
        transform: 'translateY(-100%)',
        transition: 'transform 0.35s ease-in-out',
        boxShadow: '0px 3px 5px -1px rgba(0,0,0,0.2),0px 6px 10px 0px rgba(0,0,0,0.14),0px 1px 18px 0px rgba(0,0,0,0.12)',
    },
    bottom: {
        bottom: -shadowHeight,
        opacity: 0.5,
        transform: 'translateY(100%)',
        transition: 'transform 0.35s ease-in-out',
        boxShadow: '0px -3px 5px -1px rgba(0,0,0,0.2),0px 6px 10px 0px rgba(0,0,0,0.14),0px -1px 18px 0px rgba(0,0,0,0.12)',
    },
    slideIn: {
        transform: 'translateY(0%)',
    },
});
const ScrollableShadow = ({ scrollRef, position, className, classes }) => {
    const [canScroll, setCanScroll] = React.useState(false);
    const checkScroll = () => {
        if (!scrollRef.current)
            return;
        if (position === 'top') {
            setCanScroll(scrollRef.current.scrollTop > 0);
        }
        else if (position === 'bottom') {
            setCanScroll(scrollRef.current.scrollHeight >
                scrollRef.current.clientHeight + scrollRef.current.scrollTop);
        }
    };
    React.useEffect(() => {
        if (!scrollRef.current)
            return;
        scrollRef.current.addEventListener('scroll', checkScroll, false);
        return () => {
            if (!scrollRef.current)
                return;
            scrollRef.current.removeEventListener('scroll', checkScroll, false);
        };
    }, [checkScroll, scrollRef]);
    React.useEffect(checkScroll);
    return ((0, jsx_runtime_1.jsx)("div", { className: (0, classnames_1.default)(classes.root, classes[position], canScroll && classes.slideIn, className) }, void 0));
};
exports.ScrollableShadow = ScrollableShadow;
exports.default = (0, withStyles_1.default)(styles)(exports.ScrollableShadow);
//# sourceMappingURL=ScrollableShadow.js.map