"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PlaylistThumbnail = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const Https_1 = __importDefault(require("@material-ui/icons/Https"));
const classnames_1 = __importDefault(require("classnames"));
const is_touch_device_1 = __importDefault(require("is-touch-device"));
const React = __importStar(require("react"));
const Button_1 = __importDefault(require("../../core/Button"));
const Checkbox_1 = __importDefault(require("../../core/Checkbox"));
const Scrollable_1 = __importDefault(require("../../layout/Scrollable"));
const withStyles_1 = __importDefault(require("../../core/withStyles"));
const helpers_1 = require("../../helpers");
const PlaylistThumbnail_styles_1 = __importDefault(require("./PlaylistThumbnail.styles"));
class PlaylistThumbnail extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            isHover: false,
            editPopoverOpen: false,
        };
        this.handleMouseOver = () => {
            this.setState({ isHover: true });
        };
        this.handleMouseLeave = () => {
            this.setState({ isHover: false });
        };
    }
    render() {
        const { classes, selected, isLocked, showControls, onEdit, onSelect, onClick, testId, } = this.props;
        const { isHover } = this.state;
        const imageUrl = 'https://assets.raydiant.com/playlist-thumbnail.svg';
        const hasControls = onEdit || onSelect;
        const shouldShowControls = showControls || (hasControls && isHover);
        const shouldShowEdit = !isLocked && onEdit && shouldShowControls;
        const shouldShowSelect = (onSelect && shouldShowControls) || selected;
        const shouldShowOverlay = shouldShowControls || selected;
        // Don't attached mouse over / leave for touch devices.
        const shouldAddMouseEvents = !(0, is_touch_device_1.default)();
        return ((0, jsx_runtime_1.jsxs)("div", Object.assign({ className: (0, classnames_1.default)(classes.root, onClick && classes.clickable), onMouseOver: shouldAddMouseEvents ? this.handleMouseOver : undefined, onMouseLeave: shouldAddMouseEvents ? this.handleMouseLeave : undefined, onClick: onClick }, (0, helpers_1.testAttr)(testId), { children: [(0, jsx_runtime_1.jsx)("div", { className: classes.image, style: {
                        backgroundImage: `url(${imageUrl})`,
                    } }, void 0), shouldShowOverlay && (0, jsx_runtime_1.jsx)("div", { className: classes.overlay }, void 0), shouldShowEdit && ((0, jsx_runtime_1.jsx)("div", Object.assign({ className: shouldShowSelect ? classes.topRight : classes.topLeft }, { children: (0, jsx_runtime_1.jsx)(Button_1.default, { color: "light", icon: "edit", onClick: (0, helpers_1.stopPropagation)(onEdit), testId: testId ? `${testId}-edit` : '' }, void 0) }), void 0)), isLocked && ((0, jsx_runtime_1.jsx)("div", Object.assign({ className: classes.lock }, { children: (0, jsx_runtime_1.jsx)(Https_1.default, { fontSize: "inherit" }, void 0) }), void 0)), shouldShowSelect && ((0, jsx_runtime_1.jsx)(Scrollable_1.default.VisibilitySensor, { children: ({ visibilityRef, isVisible }) => ((0, jsx_runtime_1.jsx)("div", Object.assign({ ref: visibilityRef, className: classes.topLeft }, { children: isVisible && ((0, jsx_runtime_1.jsx)(Checkbox_1.default, { round: true, 
                            // @ts-ignore
                            checked: selected, onChange: onSelect, onClick: (0, helpers_1.stopPropagation)(), testId: testId ? `${testId}-select` : '' }, void 0)) }), void 0)) }, void 0))] }), void 0));
    }
}
exports.PlaylistThumbnail = PlaylistThumbnail;
PlaylistThumbnail.defaultProps = {
    selected: false,
    showControls: false,
    isLoading: false,
};
exports.default = (0, withStyles_1.default)(PlaylistThumbnail_styles_1.default)(PlaylistThumbnail);
//# sourceMappingURL=PlaylistThumbnail.js.map