"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PresentationBuilder = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
// NOTE: PresentationBuilder is deprecated. Use PresentationForm and PresentationPreview instead.
// This component only exists to avoid breaking the RaydiantKit simulator.
// @ts-nocheck
const immutable = __importStar(require("object-path-immutable"));
const React = __importStar(require("react"));
const ActionBar_1 = __importDefault(require("../../core/ActionBar"));
const Button_1 = __importDefault(require("../../core/Button"));
const Form_1 = __importDefault(require("../../core/Form"));
const ThemeBackground_1 = __importDefault(require("../../core/ThemeBackground"));
const Link_1 = __importDefault(require("../../core/Link"));
const Popover_1 = __importDefault(require("../../core/Popover"));
const withStyles_1 = __importDefault(require("../../core/withStyles"));
const withThemeSelector_1 = __importDefault(require("../../core/withThemeSelector"));
const Callout_1 = __importDefault(require("../../core/Callout"));
const ThemeSelector_1 = __importDefault(require("../../core/ThemeSelector"));
const AffectedScreensPopover_1 = __importDefault(require("../../devices/AffectedScreensPopover"));
const Hidden_1 = __importDefault(require("../../layout/Hidden"));
const Scrollable_1 = __importDefault(require("../../layout/Scrollable"));
const OneThirdLayout_1 = __importDefault(require("../../layout/OneThirdLayout"));
const Spacer_1 = __importDefault(require("../../layout/Spacer"));
const Text_1 = __importDefault(require("../../typography/Text"));
const P = __importStar(require("../PresentationTypes"));
const PresentationForm_1 = __importDefault(require("../PresentationForm"));
const PresentationPreview_1 = __importDefault(require("../PresentationPreview"));
const validatePresentation_1 = __importDefault(require("./validatePresentation"));
const hasPresentationChanged_1 = __importDefault(require("./hasPresentationChanged"));
const PresentationBuilder_styles_1 = __importDefault(require("./PresentationBuilder.styles"));
class PresentationBuilder extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            previewPresentation: this.props.presentation,
            validate: false,
            previewMode: this.props.previewMode,
            showAffectedDevices: false,
        };
        this.fileBlobs = {};
        this.handleSave = () => {
            if (this.validate().length === 0) {
                this.props.onSave();
            }
        };
        this.handleDone = () => {
            if (this.validate().length === 0) {
                this.props.onDone();
            }
        };
    }
    componentDidUpdate(prevProps) {
        const { presentation } = this.props;
        if (!prevProps.presentation && presentation) {
            this.setState({ previewPresentation: presentation });
        }
        if (prevProps.presentation &&
            presentation &&
            prevProps.presentation.id !== presentation.id
        // Commenting the below check out because it causes the preview to render when typing
        // into a property that was just added via conditional controls (ie. qr code url). This
        // started happening after updating the Dashboard to use the new playlist renderer code.
        // We'll need to find a better fix for the below issue (if it still exists) but leaving this
        // check in as documentation for when we update RaydiantKit to the latest playlist renderer.
        //
        // This is only here because of RaydiantKit in order to re-render the preview
        // when the values change outside of the form.
        // || Object.keys(prevProps.presentation.applicationVariables).length !==
        //   Object.keys(presentation.applicationVariables).length
        ) {
            this.setState({ previewPresentation: presentation });
        }
    }
    validate() {
        const { appVersion, minDuration, presentation } = this.props;
        this.setState({ validate: true });
        return (0, validatePresentation_1.default)(presentation, appVersion, minDuration);
    }
    renderWarnings() {
        const { initialPresentationState, presentation, appVersion, affectedDevices, localUploads, } = this.props;
        const warnings = [];
        if (initialPresentationState.appVersionId !== appVersion.id) {
            warnings.push('Saving will update content to the newer version of the app, and may cause visual changes.');
        }
        if (affectedDevices.length &&
            (0, hasPresentationChanged_1.default)(initialPresentationState, presentation, appVersion, localUploads)) {
            const count = affectedDevices.length;
            warnings.push((0, jsx_runtime_1.jsxs)("span", { children: ["Saving these changes will affect\u00A0", (0, jsx_runtime_1.jsx)(Link_1.default, Object.assign({ onClick: () => this.setState({ showAffectedDevices: true }) }, { children: count > 1 ? `${count} screens` : '1 screen' }), void 0)] }, void 0));
        }
        return warnings.map((warning, i) => (0, jsx_runtime_1.jsx)(Callout_1.default, { children: warning }, i));
    }
    renderPreview() {
        const { appVersion, children, localUploads, minDuration } = this.props;
        const { previewMode } = this.state;
        let { previewPresentation } = this.state;
        const isLoading = !appVersion || !previewPresentation;
        if (isLoading) {
            return ((0, jsx_runtime_1.jsx)(ThemeSelector_1.default, Object.assign({ color: "dark" }, { children: (0, jsx_runtime_1.jsx)(ThemeBackground_1.default, {}, void 0) }), void 0));
        }
        // Inject local upload file URL's into the preview.
        localUploads.forEach(({ path, localUrl }) => {
            previewPresentation = immutable.set(previewPresentation, [...path, 'url'], localUrl);
        });
        const previewErrors = previewPresentation
            ? (0, validatePresentation_1.default)(previewPresentation, appVersion, minDuration)
            : [];
        return ((0, jsx_runtime_1.jsx)(ThemeSelector_1.default, Object.assign({ color: "dark" }, { children: (0, jsx_runtime_1.jsx)(PresentationPreview_1.default, Object.assign({ appVersion: appVersion, previewMode: previewMode, onPreviewModeChange: (value) => this.setState({ previewMode: value }) }, { children: children(previewPresentation, previewErrors) }), void 0) }), void 0));
    }
    render() {
        const { initialPresentationState, presentation, appVersion, themes, onSave, affectedDevices, onBack, backToLabel, header, onDone, didSave, minDuration, localUploads, soundZones, playlists, selectedPlaylistPath, onBuilderStateChange, onPlaylistEdit, onPlaylistCreate, onPlaylistSelect, onStateChange, classes, } = this.props;
        const { showAffectedDevices, validate } = this.state;
        const isLoading = !initialPresentationState || !presentation || !appVersion;
        const isNew = presentation && !presentation.id;
        // Don't update the preview if there are any errors.
        const formErrors = validate
            ? (0, validatePresentation_1.default)(presentation, appVersion, minDuration)
            : [];
        // Disabled save if we're still loading, if the presentation is invalid (after save) or if
        // we're editing an existing presentation and there are no changes.
        const shouldDisableSave = isLoading ||
            formErrors.length > 0 ||
            (!isNew &&
                !(0, hasPresentationChanged_1.default)(initialPresentationState, presentation, appVersion, localUploads));
        const shouldDisableDone = shouldDisableSave && !didSave;
        return ((0, jsx_runtime_1.jsxs)(OneThirdLayout_1.default, { children: [(0, jsx_runtime_1.jsxs)(OneThirdLayout_1.default.ColumnSmall, { children: [(0, jsx_runtime_1.jsxs)(Scrollable_1.default, { children: [(0, jsx_runtime_1.jsx)(Hidden_1.default, Object.assign({ smUp: true }, { children: this.renderPreview() }), void 0), (0, jsx_runtime_1.jsxs)(Form_1.default.Section, { children: [onBack && ((0, jsx_runtime_1.jsx)(Hidden_1.default, Object.assign({ xsDown: true }, { children: (0, jsx_runtime_1.jsx)(Button_1.default, { icon: "arrowLeft", label: backToLabel || 'Back', onClick: onBack }, void 0) }), void 0)), (0, jsx_runtime_1.jsx)(Text_1.default, Object.assign({ muted: true }, { children: "Presentation Details" }), void 0), header && (0, jsx_runtime_1.jsx)("div", { children: header }, void 0)] }, void 0), !isLoading && ((0, jsx_runtime_1.jsx)(PresentationForm_1.default, { className: classes.inputs, presentation: presentation, appVersion: appVersion, errors: formErrors, themes: themes, soundZones: soundZones, playlists: playlists, selectedPlaylistPath: selectedPlaylistPath, onPlaylistEdit: onPlaylistEdit, onPlaylistCreate: onPlaylistCreate, onPlaylistSelect: onPlaylistSelect, onChange: (updatedPresentation, updatedLocalUploads) => {
                                        onStateChange(updatedPresentation, updatedLocalUploads);
                                        const updateErrors = (0, validatePresentation_1.default)(updatedPresentation, appVersion, minDuration);
                                        if (updateErrors.length === 0) {
                                            this.setState({ previewPresentation: updatedPresentation });
                                        }
                                    }, onBuilderStateChange: onBuilderStateChange }, void 0))] }, void 0), !isLoading && this.renderWarnings(), (0, jsx_runtime_1.jsxs)(ActionBar_1.default, Object.assign({ condensed: true, color: "light" }, { children: [(0, jsx_runtime_1.jsx)(Spacer_1.default, {}, void 0), onDone && ((0, jsx_runtime_1.jsx)(Button_1.default, { label: "Done", color: "primary", disabled: shouldDisableDone, onClick: this.handleDone }, void 0)), onSave && ((0, jsx_runtime_1.jsxs)(Popover_1.default.Anchor, { children: [(0, jsx_runtime_1.jsx)(Button_1.default, { label: "Save", color: "progress", disabled: shouldDisableSave, onClick: this.handleSave }, void 0), (0, jsx_runtime_1.jsx)(AffectedScreensPopover_1.default, { open: showAffectedDevices, devices: affectedDevices, onClose: () => this.setState({ showAffectedDevices: false }) }, void 0)] }, void 0))] }), void 0)] }, void 0), (0, jsx_runtime_1.jsx)(OneThirdLayout_1.default.ColumnLarge, { children: this.renderPreview() }, void 0)] }, void 0));
    }
}
exports.PresentationBuilder = PresentationBuilder;
PresentationBuilder.defaultProps = {
    themes: [],
    soundZones: [],
    playlists: [],
    affectedDevices: [],
    localUploads: [],
    minDuration: 5,
    previewMode: P.PreviewMode.Horizontal,
};
exports.default = (0, withThemeSelector_1.default)((0, withStyles_1.default)(PresentationBuilder_styles_1.default)(PresentationBuilder));
//# sourceMappingURL=PresentationBuilder.js.map