"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const Link_1 = __importDefault(require("../../core/Link"));
const PresentationFormHelperText = ({ property, path, strings, error, }) => {
    if (error) {
        return (0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: error }, void 0);
    }
    if (property.helper_link) {
        return ((0, jsx_runtime_1.jsx)(Link_1.default, Object.assign({ target: "_blank", href: property.helper_link }, { children: (property.helper_text && strings[property.helper_text]) ||
                property.helper_text }), void 0));
    }
    if (property.helper_text) {
        return (0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: strings[property.helper_text] || property.helper_text }, void 0);
    }
    if (path.length <= 2 && property.type !== 'playlist') {
        // Inputs should always account for helper text spacing even if there isn't
        // any helper text displayed but only at the root (when path <= 2) or unless
        // its a playlist type.
        return (0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: "\u00A0" }, void 0);
    }
    return null;
};
exports.default = PresentationFormHelperText;
//# sourceMappingURL=PresentationFormHelperText.js.map