"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const React = __importStar(require("react"));
const SelectedPathContext = React.createContext(null);
function withSelectedPath(Component) {
    class WrappedComponent extends React.Component {
        constructor() {
            super(...arguments);
            this.state = {
                selectedPath: [],
                prevSelectedPath: [],
            };
            this.setSelectedPath = (selectedPath) => {
                this.setState((state) => ({
                    selectedPath,
                    prevSelectedPath: state.selectedPath,
                }));
                this.props.onInputStateChange({ selectedPath });
            };
        }
        render() {
            // Nested array inputs need to share the selectedPath state from the top
            // level array input. React's context feature is used to pass selectedPath
            // and setSelectedPath to child array inputs.
            return ((0, jsx_runtime_1.jsx)(SelectedPathContext.Consumer, { children: (context) => {
                    if (context) {
                        // Context is defined so we know we're rendering a child array input.
                        return ((0, jsx_runtime_1.jsx)(Component, Object.assign({}, this.props, { selectedPath: context.selectedPath, prevSelectedPath: context.prevSelectedPath, setSelectedPath: context.setSelectedPath }), void 0));
                    }
                    return ((0, jsx_runtime_1.jsx)(SelectedPathContext.Provider, Object.assign({ value: {
                            selectedPath: this.state.selectedPath,
                            prevSelectedPath: this.state.selectedPath,
                            setSelectedPath: this.setSelectedPath,
                        } }, { children: (0, jsx_runtime_1.jsx)(Component, Object.assign({}, this.props, { selectedPath: this.state.selectedPath, prevSelectedPath: this.state.prevSelectedPath, setSelectedPath: this.setSelectedPath }), void 0) }), void 0));
                } }, void 0));
        }
    }
    // @ts-ignore
    return WrappedComponent;
}
exports.default = withSelectedPath;
//# sourceMappingURL=withSelectedPath.js.map