"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const FileField_1 = __importDefault(require("../../../../core/FileField"));
const FakeFileList_1 = __importDefault(require("./FakeFileList"));
const FileInput = ({ label, value, constraints, helperText, error, disabled, onChange, }) => {
    // FileField accepts a FileList as it's value so for existing uploads to display
    // the file name in the input we need to create a fake FileList.
    let fakeFileList;
    if (value && value.filename) {
        fakeFileList = new FakeFileList_1.default();
        fakeFileList.add(value.filename);
    }
    return ((0, jsx_runtime_1.jsx)(FileField_1.default, { label: label, value: fakeFileList, helperText: helperText, error: error, disabled: disabled, accept: constraints['content-types'], onChange: (fileList) => {
            if (fileList && fileList.length) {
                // We don't support multiple files per presentation property.
                const file = fileList[0];
                onChange(
                // Convert to expected file upload structure for API.
                {
                    filename: file.name,
                    url: URL.createObjectURL(file),
                    'content-type': file.type,
                    'content-length': file.size,
                }, 
                // The raw file blob is passed separately to allow for uploading.
                file);
            }
        }, onClear: () => onChange(null, null) }, void 0));
};
exports.default = FileInput;
//# sourceMappingURL=FileInput.js.map