"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const React = __importStar(require("react"));
const styles_1 = require("@material-ui/core/styles");
const Button_1 = __importDefault(require("../../../../core/Button"));
const Modal_1 = __importDefault(require("../../../../core/Modal"));
const replacePropNameWithValue_1 = __importDefault(require("../../../../helpers/replacePropNameWithValue"));
const createTheme_1 = __importDefault(require("../../../../theme/createTheme"));
const FormHelperText_1 = __importDefault(require("../../../../internal/FormHelperText"));
const EmbeddedFrame_1 = __importDefault(require("./EmbeddedFrame"));
class ModalButton extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            open: false,
        };
        this.close = () => {
            this.setState({ open: false });
        };
        this.handleMessage = (type, payload) => {
            const { onChange = () => { } } = this.props;
            switch (type) {
                case 'update':
                    onChange({ open: this.state.open, value: payload });
                    break;
                case 'close':
                    this.close();
                    onChange({ open: false, value: payload });
                    break;
            }
        };
        this.handleOnClick = () => {
            const { onChange = () => { } } = this.props;
            this.setState({ open: true });
            onChange({ open: true });
        };
        this.handleOverlayClick = () => {
            const { onChange = () => { } } = this.props;
            this.close();
            onChange({ open: false });
        };
    }
    render() {
        const { label, sourceUrl, disabled, parentValue, helperText, backgroundColor, hoveredBackgroundColor, textColor, } = this.props;
        const theme = (outerTheme) => (0, createTheme_1.default)(Object.assign(Object.assign({}, outerTheme), { modal: Object.assign(Object.assign({}, outerTheme.modal), { maxWidth: '90%', maxHeight: '90%' }), palette: Object.assign(Object.assign({}, outerTheme.palette), { primary: {
                    main: backgroundColor || outerTheme.palette.primary.main,
                    dark: hoveredBackgroundColor || outerTheme.palette.primary.dark,
                    contrastText: textColor || outerTheme.palette.primary.contrastText,
                } }) }));
        const url = (0, replacePropNameWithValue_1.default)(sourceUrl, parentValue || {}, true);
        return ((0, jsx_runtime_1.jsxs)(styles_1.ThemeProvider, Object.assign({ theme: theme }, { children: [(0, jsx_runtime_1.jsxs)("div", { children: [(0, jsx_runtime_1.jsx)(Button_1.default, { fullWidth: true, color: "primary", label: label, disabled: disabled, onClick: this.handleOnClick }, void 0), helperText && ((0, jsx_runtime_1.jsx)(FormHelperText_1.default, Object.assign({ disabled: disabled }, { children: helperText }), void 0))] }, void 0), (0, jsx_runtime_1.jsx)(Modal_1.default, Object.assign({ open: this.state.open, onOverlayClick: this.handleOverlayClick }, { children: (0, jsx_runtime_1.jsx)(EmbeddedFrame_1.default, { src: url, onMessage: this.handleMessage }, void 0) }), void 0)] }), void 0));
    }
}
ModalButton.defaultProps = {
    label: '',
    sourceUrl: '',
};
exports.default = ModalButton;
//# sourceMappingURL=ModalButton.js.map