"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const NumberField_1 = __importDefault(require("../../../../core/NumberField"));
const isValid = (value) => value !== undefined && value !== null && value !== '' && !isNaN(value);
const NumberInput = ({ label, value, defaultValue, constraints, helperText, error, disabled, onChange, }) => ((0, jsx_runtime_1.jsx)(NumberField_1.default, { label: label, value: value, onChange: onChange, helperText: helperText, error: error, disabled: disabled, min: constraints.min, max: constraints.max, onBlur: () => {
        if (isValid(defaultValue) && !isValid(value)) {
            onChange(defaultValue);
        }
        else if (isValid(constraints.min) &&
            (!isValid(value) || value < constraints.min)) {
            onChange(constraints.min);
        }
        else if (isValid(constraints.max) &&
            value > constraints.max) {
            onChange(constraints.max);
        }
    } }, void 0));
exports.default = NumberInput;
//# sourceMappingURL=NumberInput.js.map