"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NEW_PLAYLIST_VALUE = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const React = __importStar(require("react"));
const Button_1 = __importDefault(require("../../../../core/Button"));
const SelectField_1 = __importDefault(require("../../../../core/SelectField"));
const Row_1 = __importDefault(require("../../../../layout/Row"));
exports.NEW_PLAYLIST_VALUE = 'new';
class PlaylistInput extends React.Component {
    constructor() {
        super(...arguments);
        this.handleChange = (value) => {
            const { onChange = () => { }, onCreate = () => { } } = this.props;
            if (value === exports.NEW_PLAYLIST_VALUE) {
                onCreate();
            }
            else {
                onChange(value);
            }
        };
    }
    componentDidMount() {
        this.checkDefaultValue();
    }
    componentDidUpdate(prevProps) {
        const { playlists } = this.props;
        const didPlaylistsChange = playlists.length !== prevProps.playlists.length ||
            playlists.some((p, i) => p.id !== prevProps.playlists[i].id);
        if (didPlaylistsChange) {
            this.checkDefaultValue();
        }
    }
    checkDefaultValue() {
        const { value, propertyTypeIndex, playlists, onChange } = this.props;
        // Set default playlist if one doesn't exist. Uses propertyTypeIndex to pick
        // another playlist when there are multiple zones.
        if (playlists.length > 0 && (!value || !this.isValueInPlaylists())) {
            this.onChangeTimeout = setTimeout(() => {
                // This ensures we pick the second playlist as the default for zone2 of MZ
                // if there is more than one user playlist.
                const defaultPlaylistIndex = Math.min(propertyTypeIndex, playlists.length - 1);
                onChange(playlists[defaultPlaylistIndex].id);
            });
        }
    }
    isValueInPlaylists() {
        const { value, playlists } = this.props;
        return !!playlists.map((pl) => pl.id).includes(value);
    }
    componentWillUnmount() {
        clearTimeout(this.onChangeTimeout);
    }
    render() {
        const { label, value, playlists, helperText, error, disabled, onEdit, onCreate, } = this.props;
        const options = playlists.map((pl) => ({
            value: pl.id,
            name: pl.name,
        }));
        const valueOrDefault = value || (options[0] ? options[0].value : '');
        if (onCreate && !playlists.length) {
            return ((0, jsx_runtime_1.jsx)(Button_1.default, { color: "primary", label: `Create a Playlist for ${label}`, onClick: onCreate, disabled: disabled }, void 0));
        }
        return ((0, jsx_runtime_1.jsxs)(Row_1.default, { children: [(0, jsx_runtime_1.jsxs)(SelectField_1.default, Object.assign({ label: label, value: valueOrDefault, onChange: this.handleChange, helperText: helperText, error: error, disabled: disabled }, { children: [onCreate && ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)("option", Object.assign({ value: exports.NEW_PLAYLIST_VALUE }, { children: "New Empty Playlist" }), void 0), (0, jsx_runtime_1.jsx)("option", Object.assign({ value: "new-separator", disabled: true }, { children: "--------------------------" }), void 0)] }, void 0)), options.map((opt) => ((0, jsx_runtime_1.jsx)("option", Object.assign({ value: opt.value }, { children: opt.name }), opt.value))), options.length === 0 && (0, jsx_runtime_1.jsx)("option", Object.assign({ disabled: true }, { children: "No playlists found" }), void 0)] }), void 0), onEdit && ((0, jsx_runtime_1.jsx)("div", Object.assign({ style: { marginTop: 19 } }, { children: (0, jsx_runtime_1.jsx)(Button_1.default, { icon: "edit", disabled: disabled, onClick: () => onEdit(valueOrDefault) }, void 0) }), void 0))] }, void 0));
    }
}
exports.default = PlaylistInput;
//# sourceMappingURL=PlaylistInputLegacy.js.map