"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const React = __importStar(require("react"));
const SelectField_1 = __importDefault(require("../../../../core/SelectField"));
class SoundZone extends React.Component {
    componentDidMount() {
        this.checkDefaultValue();
    }
    componentDidUpdate(prevProps) {
        const { soundZones } = this.props;
        const didSoundZonesChange = soundZones.length !== prevProps.soundZones.length ||
            soundZones.some((sz, i) => sz.id !== prevProps.soundZones[i].id);
        if (didSoundZonesChange) {
            this.checkDefaultValue();
        }
    }
    checkDefaultValue() {
        const { value, soundZones, onChange } = this.props;
        // Default to first sound zone if value is not set.
        if (!value && soundZones.length > 0) {
            this.onChangeTimeout = setTimeout(() => {
                onChange(soundZones[0].id);
            });
        }
    }
    componentWillUnmount() {
        clearTimeout(this.onChangeTimeout);
    }
    render() {
        const { label, value, soundZones, helperText, error, disabled, onChange } = this.props;
        const soundZone = soundZones.find((sz) => sz.id === value);
        // Assume the soundzone was assigned by an admin if there is a soundzone id but we can't
        // find it in the current user's soundzones. This is a workaround, ideally the API would return
        // the basic information about the assigned soundzone if the current user doesn't have access to it.
        const isAdminAssigned = value && !soundZone;
        const options = soundZones.map((sz) => ({
            value: sz.id,
            name: sz.name,
        }));
        return ((0, jsx_runtime_1.jsxs)(SelectField_1.default, Object.assign({ label: label, value: value || (options[0] ? options[0].value : ''), onChange: onChange, helperText: helperText, error: error, disabled: disabled }, { children: [isAdminAssigned && ((0, jsx_runtime_1.jsx)("option", Object.assign({ value: value }, { children: " Administrator assigned sound zone" }), void 0)), options.map((opt) => ((0, jsx_runtime_1.jsx)("option", Object.assign({ value: opt.value }, { children: opt.name }), opt.value))), options.length === 0 && ((0, jsx_runtime_1.jsx)("option", Object.assign({ disabled: true }, { children: "No paired zones found" }), void 0))] }), void 0));
    }
}
exports.default = SoundZone;
//# sourceMappingURL=SoundZoneInput.js.map