"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const SelectField_1 = __importDefault(require("../../../../core/SelectField"));
const ThemeInputLegacy = ({ label, value, themes, helperText, error, disabled, onChange, }) => {
    const theme = themes.find((pl) => pl.id === value);
    // Assume the theme was assigned by an admin if there is a theme id but we can't
    // find it in the current user's themes. This is a workaround, ideally the API would return
    // the basic information about the assigned theme if the current user doesn't have access to it.
    const isAdminAssigned = value && !theme;
    const options = themes
        .filter((t) => !t.resource.deletedAt)
        .map((t) => ({
        value: t.id,
        name: t.name,
    }));
    return ((0, jsx_runtime_1.jsxs)(SelectField_1.default, Object.assign({ label: label, value: value || (options[0] ? options[0].value : ''), onChange: onChange, helperText: helperText, error: error, disabled: disabled }, { children: [isAdminAssigned && ((0, jsx_runtime_1.jsx)("option", Object.assign({ value: value }, { children: " Administrator assigned theme" }), void 0)), options.map((opt) => ((0, jsx_runtime_1.jsx)("option", Object.assign({ value: opt.value }, { children: opt.name }), opt.value)))] }), void 0));
};
exports.default = ThemeInputLegacy;
//# sourceMappingURL=ThemeInputLegacy.js.map