"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const getItemLabel_1 = __importDefault(require("./getItemLabel"));
const defaultLabel = 'default';
test('Returns default for empty label', () => {
    const properties = [{ name: 'value', type: 'string' }];
    expect((0, getItemLabel_1.default)({ value: '' }, properties, defaultLabel)).toBe(defaultLabel);
    expect((0, getItemLabel_1.default)({ value: null }, properties, defaultLabel)).toBe(defaultLabel);
    expect((0, getItemLabel_1.default)({ value: undefined }, properties, defaultLabel)).toBe(defaultLabel);
});
test('Returns string for array', () => {
    const properties = [{ name: 'value', type: 'array' }];
    expect((0, getItemLabel_1.default)({ value: ['a', 'b'] }, properties, defaultLabel)).toBe('a, b');
});
test('Returns string for number', () => {
    const properties = [{ name: 'value', type: 'number' }];
    expect((0, getItemLabel_1.default)({ value: 1 }, properties, defaultLabel)).toBe('1');
});
test('Returns string for boolean', () => {
    const properties = [{ name: 'value', type: 'number' }];
    expect((0, getItemLabel_1.default)({ value: true }, properties, defaultLabel)).toBe('true');
});
//# sourceMappingURL=getItemLabel.test.js.map