"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const getPropertyAtPath_1 = __importDefault(require("./getPropertyAtPath"));
const properties = [
    {
        name: 'categoryName',
        type: 'string',
    },
    {
        name: 'items',
        type: 'array',
        properties: [
            {
                name: 'itemName',
                type: 'string',
            },
        ],
    },
];
test('Should return property for path', () => {
    expect((0, getPropertyAtPath_1.default)(properties, ['items'])).toEqual({
        name: 'items',
        type: 'array',
        properties: [
            {
                name: 'itemName',
                type: 'string',
            },
        ],
    });
});
test('Should skip numbers in path', () => {
    expect((0, getPropertyAtPath_1.default)(properties, [1, 'items', 2])).toEqual({
        name: 'items',
        type: 'array',
        properties: [
            {
                name: 'itemName',
                type: 'string',
            },
        ],
    });
});
test('Should return property for nested path', () => {
    expect((0, getPropertyAtPath_1.default)(properties, ['items', 'itemName'])).toEqual({
        name: 'itemName',
        type: 'string',
    });
});
//# sourceMappingURL=getPropertyAtPath.test.js.map