"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OccurrenceListItem = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const classnames_1 = __importDefault(require("classnames"));
const moment_1 = __importDefault(require("moment"));
const Icon_1 = __importDefault(require("../../core/Icon"));
const withStyles_1 = __importStar(require("../../core/withStyles"));
const helpers_1 = require("../../helpers");
const Heading2_1 = __importDefault(require("../../typography/Heading2"));
const Text_1 = __importDefault(require("../../typography/Text"));
const OccurrenceListItem = ({ classes, name, start, end, overridden, locked, recurring, onClick, testId, }) => {
    const startTime = (0, moment_1.default)(start);
    const endTime = (0, moment_1.default)(end);
    const sameDate = startTime.isSame(endTime, 'date');
    const sameYear = startTime.year() === endTime.year();
    let dateFormat = 'h:mm A';
    if (!sameDate && !sameYear) {
        dateFormat = `${dateFormat} (MMM D, YY)`;
    }
    else if (!sameDate) {
        dateFormat = `${dateFormat} (MMM D)`;
    }
    const startTimeText = startTime.format(dateFormat);
    const endTimeText = endTime.format(dateFormat);
    const occurrenceName = overridden ? ((0, jsx_runtime_1.jsx)(Text_1.default, Object.assign({ small: true, strikethrough: true, ellipsis: true }, { children: name }), void 0)) : ((0, jsx_runtime_1.jsx)(Heading2_1.default, Object.assign({ ellipsis: true }, { children: name }), void 0));
    return ((0, jsx_runtime_1.jsxs)("div", Object.assign({ onClick: onClick, className: (0, classnames_1.default)(classes.root, onClick && classes.clickable) }, (0, helpers_1.testAttr)(testId), { children: [(0, jsx_runtime_1.jsxs)("div", Object.assign({ className: (0, classnames_1.default)(classes.content, overridden && classes.overridden) }, { children: [occurrenceName, (0, jsx_runtime_1.jsxs)("div", Object.assign({ className: classes.duration }, { children: [(0, jsx_runtime_1.jsx)(Text_1.default, Object.assign({ small: true, muted: true, ellipsis: !overridden }, { children: startTimeText }), void 0), (0, jsx_runtime_1.jsx)(Text_1.default, Object.assign({ small: true, muted: true }, { children: "\u00A0\u2013\u00A0" }), void 0), (0, jsx_runtime_1.jsx)(Text_1.default, Object.assign({ small: true, muted: true, ellipsis: !overridden }, { children: endTimeText }), void 0)] }), void 0)] }), void 0), (0, jsx_runtime_1.jsxs)("div", Object.assign({ className: classes.badges }, { children: [recurring && ((0, jsx_runtime_1.jsx)(Icon_1.default, { icon: "repeat", className: (0, classnames_1.default)(classes.badge, classes.repeat) }, void 0)), locked && ((0, jsx_runtime_1.jsx)(Icon_1.default, { icon: "lock", className: (0, classnames_1.default)(classes.badge, classes.lock) }, void 0))] }), void 0)] }), void 0));
};
exports.OccurrenceListItem = OccurrenceListItem;
const styles = (theme) => (0, withStyles_1.createStyles)({
    root: {
        display: 'flex',
        borderBottomWidth: 1,
        borderBottomStyle: 'solid',
        borderBottomColor: theme.divider.secondary,
        '&:first-child': {
            borderTopLeftRadius: 2,
            borderTopRightRadius: 2,
        },
        '&:last-child': {
            borderBottomLeftRadius: 2,
            borderBottomRightRadius: 2,
        },
        backgroundColor: theme.palette.background.default,
        whiteSpace: 'nowrap',
    },
    content: {
        flex: 1,
        display: 'flex',
        flexDirection: 'column',
        paddingLeft: theme.spacing(2),
        paddingRight: theme.spacing(2),
        paddingTop: theme.spacing(1),
        paddingBottom: theme.spacing(1),
    },
    overridden: {
        display: 'inline-flex',
        flexDirection: 'row',
        justifyContent: 'space-between',
        flexWrap: 'wrap',
    },
    duration: {
        display: 'flex',
        flexShrink: 0,
        flexWrap: 'wrap',
    },
    badges: {
        flex: 0,
    },
    badge: {
        color: theme.palette.background.default,
        '&:first-child': {
            borderBottomLeftRadius: 2,
        },
    },
    lock: {
        backgroundColor: theme.palette.warning.main,
        // shrink lock icon to match line thickness of repeat icon
        padding: 2,
        boxSizing: 'border-box',
    },
    repeat: {
        backgroundColor: theme.palette.progress.main,
    },
    clickable: {
        cursor: 'pointer',
    },
});
exports.default = (0, withStyles_1.default)(styles)(exports.OccurrenceListItem);
//# sourceMappingURL=OccurrenceListItem.js.map