"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SequenceSchedule = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const moment_1 = __importDefault(require("moment"));
const React = __importStar(require("react"));
const withStyles_1 = __importStar(require("../../core/withStyles"));
const withThemeSelector_1 = __importDefault(require("../../core/withThemeSelector"));
const stateChanged_1 = __importDefault(require("../../helpers/stateChanged"));
const withScrollProvider_1 = __importDefault(require("../../internal/Scroll/withScrollProvider"));
const mixins_1 = require("../../mixins");
const Text_1 = __importDefault(require("../../typography/Text"));
const SequenceScheduleContext_1 = __importDefault(require("./SequenceScheduleContext"));
const SequenceScheduleDay_1 = __importDefault(require("./SequenceScheduleDay"));
const SequenceScheduleMonth_1 = __importDefault(require("./SequenceScheduleMonth"));
class SequenceSchedule extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            monthVisibility: {},
            currentMonth: (0, moment_1.default)().startOf('month').toDate(),
        };
        this.setMonthVisibility = (month, visibility) => {
            const monthVisibility = Object.assign(Object.assign({}, this.state.monthVisibility), { [month.toISOString()]: visibility });
            if ((0, stateChanged_1.default)(monthVisibility, this.state.monthVisibility)) {
                const currentMonth = Object.keys(monthVisibility)
                    .filter((monthStr) => monthVisibility[monthStr])
                    .map((monthStr) => new Date(monthStr))
                    .sort((month1, month2) => +month1 - +month2)[0];
                this.setState({ currentMonth, monthVisibility });
            }
        };
    }
    render() {
        const { children, classes, onScroll } = this.props;
        const { currentMonth } = this.state;
        return ((0, jsx_runtime_1.jsxs)("div", Object.assign({ className: classes.root }, { children: [(0, jsx_runtime_1.jsx)("div", Object.assign({ className: classes.currentMonthHeader }, { children: (0, jsx_runtime_1.jsx)(Text_1.default, Object.assign({ muted: true, nowrap: true }, { children: (0, moment_1.default)(currentMonth).format('MMMM YYYY') }), void 0) }), void 0), (0, jsx_runtime_1.jsx)("div", Object.assign({ className: classes.months, onScroll: onScroll }, { children: (0, jsx_runtime_1.jsx)(SequenceScheduleContext_1.default.Provider, Object.assign({ value: {
                            setMonthVisibility: this.setMonthVisibility,
                        } }, { children: children }), void 0) }), void 0)] }), void 0));
    }
}
exports.SequenceSchedule = SequenceSchedule;
const styles = (theme) => (0, withStyles_1.createStyles)({
    root: {
        display: 'flex',
        flexDirection: 'column',
        flex: 1,
        overflow: 'hidden',
    },
    currentMonthHeader: {
        paddingTop: theme.spacing(1),
        paddingBottom: theme.spacing(1),
        paddingLeft: theme.spacing(2),
        paddingRight: theme.spacing(2),
        borderBottomColor: theme.divider.secondary,
        borderBottomStyle: 'solid',
        borderBottomWidth: 1,
    },
    months: Object.assign(Object.assign({}, (0, mixins_1.scrollable)()), { position: 'relative' }),
});
exports.default = Object.assign(
// @ts-ignore
(0, withScrollProvider_1.default)((0, withThemeSelector_1.default)((0, withStyles_1.default)(styles)(SequenceSchedule))), {
    Day: SequenceScheduleDay_1.default,
    Month: SequenceScheduleMonth_1.default,
});
//# sourceMappingURL=SequenceSchedule.js.map